package jp.ac.nime.computer.grpsimulator;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;

/** t[GWJpp^ݒ _CAO
 * @version 1.0.0
 * @author  igarashi
 */
public class DlgAnalyzeFourier extends JPanel
	implements OperationDialog, ParameterSetting
{
	
	private ActionListener actionListener_;

	private int nButton_;
	
	private JTextField jTextField_;
	private JButton jButton1_;
	private JButton jButton2_;

	/** Creates new form DlgAnalyzeFourier */
	public DlgAnalyzeFourier() {
		initComponents();
		nButton_ = 0;
	}
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 */
    private void initComponents() {
		setLayout(new GridBagLayout());
		setBorder(new TitledBorder(GrpSim.res_.getString("DlgAnalyzeFourierCaption")));
		setPreferredSize(new Dimension(240, 240));
		
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		
		jButton1_ = new JButton();
		jButton1_.setText(GrpSim.res_.getString("DlgAnalyzeFourierButtonInit"));
		jButton1_.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				jButton1_ActionPerformed(evt);
			}
		});
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = 2;
		gridBagConstraints.insets = new Insets(10, 10, 10, 10);
		add(jButton1_, gridBagConstraints);
		
		JLabel jLabel = new JLabel();
		jLabel.setText(GrpSim.res_.getString("DlgAnalyzeFourierLabelLimit"));
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = 1;
		gridBagConstraints.insets = new Insets(10, 10, 0, 10);
		add(jLabel, gridBagConstraints);
		
		jTextField_ = new JTextField("50",3);
		jTextField_.setHorizontalAlignment(JTextField.RIGHT);
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new Insets(0, 10, 100, 10);
		add(jTextField_, gridBagConstraints);
		
		jButton2_ = new JButton();
		jButton2_.setText(GrpSim.res_.getString("DlgAnalyzeFourierButtonExec"));
		jButton2_.setEnabled(false);
		jButton2_.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				jButton2_ActionPerformed(evt);
			}
		});
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridheight = 2;
		gridBagConstraints.insets = new Insets(10, 10, 100, 10);
		add(jButton2_, gridBagConstraints);
	}

	private void jButton2_ActionPerformed(ActionEvent evt) {
		// s
		nButton_ = 2;
		actionListener_.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,"ParameterChanged"));
	}

	private void jButton1_ActionPerformed(ActionEvent evt) {
		// QlƋEo
		nButton_ = 1;
		jButton2_.setEnabled(true);
		actionListener_.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,"ParameterChanged"));
	}

	public void addActionListener(ActionListener listener) {
		actionListener_ = AWTEventMulticaster.add(actionListener_, listener);
	}
	public void removeActionListener(ActionListener listener) {
		actionListener_ = AWTEventMulticaster.remove(actionListener_, listener);
	}
	
	/** ϊ̎ނ擾܂
	 * @return ϊ̎ނ\l
	 */
	public int getParameterType() {
		return ParameterSetting.PARAM_TYPE_ANALYZE_FOURIER;
	}
	
	/** ϊ̃p[^擾܂
	 * @return p[^\zBeɂĂ͕ϊ̎ނɈˑ܂BG[nullԂB
	 */
	public int[] getParameters() {
		// ꂽ{^̎ނfł
		int[] ret = new int[2];
		ret[0] = nButton_;
		ret[1] = Integer.valueOf(jTextField_.getText()).intValue();
		return ret;
	}
	
	/** ϊ摜KvƂ邩ǂԂ
	 * @return ϊ摜KvƂȂtrueԂ
	 */
	public boolean requireSrc() {
		return false;
	}
	
	/** _CAȌԂZbg  */
	public void resetState() {
		nButton_ = 0;
		jButton2_.setEnabled(false);
	}
	
}
