package jp.ac.nime.computer.grpsimulator;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/**
 * 摜ׂ̈̉摜obt@󂯎NXB
 * 摜o^Ƃ RGB<->YUVϊċLB
 * 摜obt@擾Ƃ RGB,YUVwłB
 * @author Kikuchi
 * @version 1.0.0
 */
public class GrpSimBuffer {
	/**
	* 摜RGBł邱Ƃ
	*/
	public static final int RGB = 0;

	/**
	* 摜YUVł邱Ƃ
	*/
	public static final int YUV = 1;

	
	private static final int IMAGE_NUMBER = 3;
	
	private static final int ING = 0; // t@C
	private static final int SRC = 1;
	private static final int DST = 2;
	private BufferedImage[] imgYuv_;
	private BufferedImage[] imgRgb_;
	private boolean recycle_;	// recycletO TURÊƂrecycle
	private int width_;	// img̉
	private int height_;	// img̏c
	private Rectangle rect_; // 摜Kvȗ̈
	private boolean[] setflag_; // ǂݍ܂ꂽǂ
	/**
	 * * RXgN^
	 * obt@̉摜TCYw肷
	 *
	 * @param width 摜̕
	 * @param height 摜̍
	 */
	public GrpSimBuffer(int width, int height) {
		recycle_ = false; // no recycle;
		width_ = width;
		height_ = height;
		imgYuv_ = new BufferedImage[IMAGE_NUMBER];
		imgRgb_ = new BufferedImage[IMAGE_NUMBER];
		setflag_ = new boolean[IMAGE_NUMBER];
		for (int i = 0; i < IMAGE_NUMBER; i ++) {
			imgYuv_[i] = new BufferedImage(width_, height_, BufferedImage.TYPE_INT_ARGB);
			imgRgb_[i] = new BufferedImage(width_, height_, BufferedImage.TYPE_INT_ARGB);
			setflag_[i] = false;
		}
		rect_ = new Rectangle();
	}


	/**
	 *  
	 * obt@̉摜TCYNXŊǗ傫ɃTCY
	 *
	 * @param img	摜obt@,TCY͓Kł܂Ȃ
	 * @param imo	C[WIuU[o[
	 * @return 傫̕ύXꂽ摜obt@
	 */
	private BufferedImage resize(BufferedImage img, ImageObserver imo) {
		int w = img.getWidth(imo);
		int h = img.getHeight(imo);
		int w2, h2;
		if ( 4*h > 3*w ) {  // h/w > 3/4 ... 320x240c
			w2 = height_* w/h;
			h2 = height_;
		} else {    // 320x240 艡
			h2 = width_ * h/w;
			w2 = width_;
		}
		Image img2 = img.getScaledInstance(w2, h2, Image.SCALE_SMOOTH);
		BufferedImage bimg = new BufferedImage(width_, height_, BufferedImage.TYPE_INT_ARGB);
		
		Graphics2D g = bimg.createGraphics();
		//g.setColor(Color.black);
		g.setColor(new Color(0, 0, 0, 0));
		g.fillRect(0, 0, width_, height_);
		g.drawImage(img2, (width_ - w2) / 2, (height_ - h2) / 2, imo);
		g.dispose();

		// ̈L
		rect_.setBounds(((width_ - w2) >> 1), ((height_ - h2) >> 1), w2, h2);

		return bimg;
	}
	
	/**
     * 
	 * obt@Src摜Ƃēo^B
	 *
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param img	摜obt@,TCY͓Kł܂Ȃ
	 * @param imo	C[WIuU[o[
	 */
	public void setSrcImage(int flag, BufferedImage img, ImageObserver imo) {
		// TCY
		BufferedImage img2 = resize(img, imo);
		// obt@ ING Ɋi[
		if (flag == RGB) {
			img2.copyData(imgRgb_[ING].getRaster());
			//imgRgb_[ING].setData(img.GetData());
			// YUV
			rgb2yuv(ING);
		} else {
			img2.copyData(imgYuv_[ING].getRaster());
			//imgYuv_[ING] = img;
			// RGB
			yuv2rgb(ING);
		}
		setflag_[ING] = true; // set
	}

	/**
	 * obt@Dst摜Ƃēo^BgKv͂Ȃ͂B
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param img	摜obt@,TCY̓RXgN^Ŏw肳Ă傫ł邱ƂKvB
	 */
	public void setDstImage(int flag, BufferedImage img) {
		// obt@ DST Ɋi[
		if (flag == RGB) {
			img.copyData(imgRgb_[DST].getRaster());
			//imgRgb_[DST] = img;
			// YUV
			rgb2yuv(DST);
		} else {
			img.copyData(imgYuv_[DST].getRaster());
			//imgYuv_[DST] = img;
			// RGB
			yuv2rgb(DST);
		}
		setflag_[DST] = true; // set
	}

	/**
	 * Dst摜ING,SRC摜Ƃ
	 * 
	 */
	public void copyDst2Ing() {
		imgRgb_[DST].copyData(imgRgb_[ING].getRaster());
		imgYuv_[DST].copyData(imgYuv_[ING].getRaster());
		imgRgb_[DST].copyData(imgRgb_[SRC].getRaster());
		imgYuv_[DST].copyData(imgYuv_[SRC].getRaster());
	}
	
	/**
	 * Dstobt@RGBYUV̓}
	 * 
	 * @param flag  ύXꂽ摜obt@BRGBw肷 RGB̓eYUVXVB
	 */
	public void syncDst(int flag) {
		if (flag == RGB) { // RGB->YUV
			rgb2yuv(DST);
		} else {	// YUV->RGB
			yuv2rgb(DST);
		}
		setflag_[DST] = true; // set
	}

	/**
	 * Srcobt@RGBYUV̓}
	 * 
	 * @param flag  ύXꂽ摜obt@BRGBw肷 RGB̓eYUVXVB
	 */
	public void syncSrc(int flag) {
		if (flag == RGB) { // RGB->YUV
			rgb2yuv(SRC);
		} else {	// YUV->RGB
			yuv2rgb(SRC);
		}
		setflag_[SRC] = true; // set
	}
	
	
	/**
	 * 摜̃\[X摜obt@񋟂
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @return 摜obt@
	 */
	public BufferedImage getSrcImage(int flag) {
		// recycle_ TRUEȂ obt@DSTobt@SRCCopy
		// FALSEȂ obt@INGobt@SRCCopy
		if (recycle_) {
			imgRgb_[DST].copyData(imgRgb_[SRC].getRaster());
			imgYuv_[DST].copyData(imgYuv_[SRC].getRaster());
		} else {
			imgRgb_[ING].copyData(imgRgb_[SRC].getRaster());
			imgYuv_[ING].copyData(imgYuv_[SRC].getRaster());
		}
		setflag_[SRC] = true; // set
		if (flag == RGB) {
			// obt@SRC RGB 
			return imgRgb_[SRC];
		} else {
			// obt@SRC YUV 
			return imgYuv_[SRC];
		}
	}
	
	/**
	 * 摜̌ʉ摜obt@񋟂
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @return 摜obt@
	 */
	public BufferedImage getDstImage(int flag) {
		// obt@ DST 
		if (flag == RGB) {
			// obt@DST RGB 
			return imgRgb_[DST];
		} else {
			// obt@DST YUV 
			return imgYuv_[DST];
		}
	}

	/**
	 * Src摜̎wʒűߖTf[^(5x5)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param x	f[^~SWx
	 * @param y	f[^~SWy
	 * @return 摜obt@
	 */
	public int[] getSrcNearPointData(int flag, int x, int y) {
		return getNearPointData(flag, SRC, x, y);
	}

	/**
	 * Dst摜̎wʒűߖTf[^(5x5)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param x	f[^~SWx
	 * @param y	f[^~SWy
	 * @return 摜obt@
	 */
	public int[] getDstNearPointData(int flag, int x, int y) {
		return getNearPointData(flag, DST, x, y);
	}

	/**
	 * 摜̎wʒűߖTf[^(5x5)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param num   f[^~摜obt@̔ԍ
	 * @param ptx	f[^~SWx
	 * @param pty	f[^~SWy
	 * @return 摜obt@
	 */
	private int[] getNearPointData(int flag, int num, int ptx, int pty) {
		int result[] = new int[25];
		BufferedImage img;
		if (flag == RGB) {
			img = imgRgb_[num];
		} else {
			img = imgYuv_[num];
		}
		for (int i = 0; i < result.length; i++) result[i] = -1;
		for (int y = 0; y < 5; y++) {
			int iy = pty + y - 2;
			if (iy < 0 || iy >= height_) continue;
			for (int x = 0; x < 5; x++) {
				int ix = ptx + x - 2;
				if (ix < 0 || ix >= width_) continue;
				result[x + y * 5] = img.getRGB(ix,iy) & 0x00FFFFFF;   // 8bit(Alpha)}XN
			}
		}
		return result;
	}

	/**
	 * Src摜̎wʒűߖTf[^(NxN)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param x	f[^~SWx
	 * @param y	f[^~SWy
	 * @param nN	ߖT̃TCY 3ȏ̊Ɍ ɓĂ͂܂ȂꍇAS|Cg̈OƂȂB
	 * @return 摜obt@
	 */
	public int[] getSrcNearPointDataN(int flag, int x, int y, int nN) {
		return getNearPointDataN(flag, SRC, x, y, nN);
	}

	/**
	 * Dst摜̎wʒűߖTf[^(5x5)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param x	f[^~SWx
	 * @param y	f[^~SWy
	 * @param nN	ߖT̃TCY 3ȏ̊Ɍ ɓĂ͂܂ȂꍇAS|Cg̈OƂȂB
	 * @return 摜obt@
	 */
	public int[] getDstNearPointDataN(int flag, int x, int y, int nN) {
		return getNearPointDataN(flag, DST, x, y, nN);
	}

	/**
	 * 摜̎wʒűߖTf[^(NxN)o͂
	 * o̓f[^́AalphäNAĂ
	 * ̈ÓA -1 ɂȂB
	 * 
	 * @param flag  摜obt@̓e YUVRGBB萔Ŏw肷邱ƁB
	 * @param num   f[^~摜obt@̔ԍ
	 * @param ptx	f[^~SWx
	 * @param pty	f[^~SWy
	 * @param nN	ߖT̃TCY 3ȏ̊Ɍ ɓĂ͂܂ȂꍇAS|Cg̈OƂȂB
	 * @return 摜obt@
	 */
	private int[] getNearPointDataN(int flag, int num, int ptx, int pty, int nN) {
		// ߂ll
		int result[] = new int[nN * nN];
		// 
		for (int i = 0; i < result.length; i++) result[i] = -1;
		if (nN < 3 || ((nN % 2) == 0)) {
			return result;
		}
		// 摜
		BufferedImage img;
		if (flag == RGB) {
			img = imgRgb_[num];
		} else {
			img = imgYuv_[num];
		}
		// f[^擾
		int nHalf = nN / 2;
		for (int y = 0; y < nN; y++) {
			int iy = pty + y - nHalf;
			if (iy < 0 || iy >= height_) continue;
			for (int x = 0; x < nN; x++) {
				int ix = ptx + x - nHalf;
				if (ix < 0 || ix >= width_) continue;
				result[x + y * nN] = img.getRGB(ix,iy) & 0x00FFFFFF;   // 8bit(Alpha)}XN
			}
		}
		return result;
	}


	/**
	 * Undos
	 * 
	 */
	public void undo() {
		// obt@ SRC̓e DSTɃRs[
		imgRgb_[SRC].copyData(imgRgb_[DST].getRaster());
		imgYuv_[SRC].copyData(imgYuv_[DST].getRaster());

		setflag_[DST] = true; // set
	}
	
	/**
	 * Recyclew肷
	 * 
	 * @param flag True:recycle ON  False:recycle OFF
	 */
	public void setRecycle(boolean flag) {
		recycle_ = flag;
	}

	/**
	 * \[X摜ǂݍł邩`FbNł
	 * 
	 * @return ǂݍł 1A
	 */
	public boolean chkValidSrc() {
		return setflag_[SRC];
	}

	/**
	 * o͉摜ǂݍł邩`FbNł
	 * @return ǂݍł 1A
	 */
	public boolean chkValidDst() {
		return setflag_[DST];
	}

	/**
     *@YUV摜RGB摜ɕϊRs[B
     * R = 1.000Y                + 1.402(V-128)
	 * G = 1.000Y - 0.344(U-128) - 0.714(V-128)
 	 * B = 1.000Y + 1.772(U-128)
	 *
	 * @param num  摜obt@̔ԍ
	 */
	private void yuv2rgb(int num) {
		if (num < 0 || num >= IMAGE_NUMBER) return;
		//WritableRaster rasSrc=imgYuv_[num].getRaster();
		//WritableRaster rasDst=imgRgb_[num].getRaster();
		for (int h = 0; h < height_; h ++) {
			for (int w = 0; w < width_; w ++) {
				int yuv = imgYuv_[num].getRGB(w, h) & 0x00ffffff; // ARGB ܂ AYUV
				int a = imgYuv_[num].getRGB(w, h) & 0xff000000;
				double y = ((yuv & 0x00ff0000) >> 16);
				double u = ((yuv & 0x0000ff00) >> 8) - 128;
				double v = ((yuv & 0x000000ff)) - 128;
				double r = y             + 1.402 * v;
				double g = y - 0.344 * u - 0.714 * v;
				double b = y + 1.772 * u;
				int ir, ig, ib, rgb;
				ir = (int)(r + 0.5);
				ig = (int)(g + 0.5);
				ib = (int)(b + 0.5);
				ir = Math.max(0, Math.min(ir, 255));
				ig = Math.max(0, Math.min(ig, 255));
				ib = Math.max(0, Math.min(ib, 255));
				rgb = ((ir << 16) + (ig << 8) + ib) | a;
				imgRgb_[num].setRGB(w, h, rgb);
			}
		}
	}

	/**
	 *@RGB摜YUV摜ɕϊRs[B
	 * Y =  0.299R + 0.587G + 0.114B
	 * U =  (-0.169R - 0.331G + 0.500B) + 128;
	 * V =  (0.500R - 0.419G - 0.081B) + 128;
	 *
	 * @param num  摜obt@̔ԍ
	 */
	private void rgb2yuv(int num) {
		if (num < 0 || num >= IMAGE_NUMBER) return;
		WritableRaster rasSrc=imgRgb_[num].getRaster();
		WritableRaster rasDst=imgYuv_[num].getRaster();

		for (int h = 0; h < height_ ; h ++) {
			for (int w = 0; w < width_; w ++) {
				int rgb = rasSrc.getDataBuffer().getElem(0, h * width_ + w) & 0x00ffffff;
				int a = rasSrc.getDataBuffer().getElem(0, h * width_ + w) & 0xff000000;
				double r = ((rgb & 0x00ff0000) >> 16);
				double g = ((rgb & 0x0000ff00) >> 8);
				double b = ((rgb & 0x000000ff));
				double y = 0.299 * r + 0.587 * g + 0.114 * b;
				double u = ((-0.169 * r) + (-0.331 * g) + (0.500 * b)) + 128.0;
				double v = ((0.500 * r) + (-0.419 * g)  + (-0.081 * b)) + 128.0;
				int iy, iu, iv, yuv;
				iy = (int)(y + 0.5);
				iu = (int)(u + 0.5);
				iv = (int)(v + 0.5);
				iy = Math.max(0, Math.min(iy, 255));
				iu = Math.max(0, Math.min(iu, 255));
				iv = Math.max(0, Math.min(iv, 255));
				yuv = ((iy << 16) + (iu << 8) + iv) | a;
				rasDst.getDataBuffer().setElem(0, h * width_ + w, yuv);
			}
		}

	}

	/**
	 *@摜TCY̕𓾂B
	 *
	 * @return 摜obt@̕
	 */
	public int getWidth() {
		return width_;
	}

	/**
	 *@摜TCY̍𓾂B
	 *
	 * @return 摜obt@̍
	 */
	public int getHeight() {
		return height_;
	}

}

