package jp.ac.nime.computer.grpsimulator;

import java.awt.*;
import java.awt.image.*;
import jp.ac.nime.computer.grpsimulator.ImgPr.*;
import jp.ac.nime.computer.grpsimulator.VecPr.*;
import java.awt.event.*;

/** ImageProcessNX́Ae摜Ăяo߂staticȃ\bhNXł
 * @version 1.0.0
 * @author igarashi
 * @author kikuchi
 */
public class ImageProcess {

	/** e摜s܂
	 * @param img Ώۂ̉摜obt@ł
	 * @param param 摜p[^wParameterSettingNX̃IuWFNg
	 * @return ɂtrue
	 * @see GrpSimBuffer
	 * @see ParameterSetting
	 */    
	public static boolean ProcessImage(GrpSimBuffer img, ParameterSetting param) {
		int params[] = param.getParameters();
		if (params != null) {
			switch( param.getParameterType() ) {

			case ParameterSetting.PARAM_TYPE_CONTRAST:
				return ProcessContrast(img, params[0]);

			case ParameterSetting.PARAM_TYPE_HIGHPASS:
				return ProcessHighPass(img, params[0]);

			case ParameterSetting.PARAM_TYPE_HIGHCUT:
				return ProcessHighCut(img, params[0]);

			case ParameterSetting.PARAM_TYPE_LABELING:
				return ProcessLabeling(img, params[0]);

			case ParameterSetting.PARAM_TYPE_DENSITYLINE:
				return ProcessDensityLine(img, params[0]);

			case ParameterSetting.PARAM_TYPE_LEVELCHANGE:
				if (params.length < 2) return false;
				return ProcessLevelChange(img, params[0], params[1]);

			case ParameterSetting.PARAM_TYPE_HISTO_PRINT:
				// qXgO̊YDstɓ]
				// 100intzAqXgȎI(0:I,1:I)
				return ProcessHistogramPrint(img, params);

			case ParameterSetting.PARAM_TYPE_HISTO_NORMAL:
				// qXgO
				// 100intzAqXgȎI(0:I,1:I)
				return ProcessHistogramNormal(img, params);

			case ParameterSetting.PARAM_TYPE_HISTO_BINARY:
				// qXgOQl
				// 100intzAqXgȎI(0:I,1:I)
				// IԂōŏlI
				int iki = -1;
				for (int i = 0; i < params.length; i ++) {
					if (params[i] == 1) { 
						iki = i; 
						break;
					}
				}
				if (iki == -1) return false;	// IĂȂ΁AȂɂȂ
			    return ProcessHistogramBinary(img, iki);

			case ParameterSetting.PARAM_TYPE_SHOW_EDGE:
				// GbWo
				// 9intz
				if (params.length < 9) return false;
				return ProcessShowEdge(img, params);

			case ParameterSetting.PARAM_TYPE_SMOOTHING:
				// 
				// 9intz
				if (params.length < 9) return false;
				return ProcessSmoothing(img, params);

			case ParameterSetting.PARAM_TYPE_REMOVE_NOISE:
				// mCY
				// 9intz
				if (params.length < 9) return false;
				return ProcessRemoveNoise(img, params);

			case ParameterSetting.PARAM_TYPE_EMPHASIS:
				// 
				// 9intz
				if (params.length < 9) return false;
				return ProcessEmphasis(img, params);

			case ParameterSetting.PARAM_TYPE_FILL_RGB:
				// 摜f[^\ F
				return ProcessFillRGB(img, params[0]);
			
			case ParameterSetting.PARAM_TYPE_DESCRIPT_POINT:
				// 摜f[^\ _
				if (param instanceof VectorDataDialog) {
					VectorDataDialog steps = (VectorDataDialog) param;
					return ProcessDescriptPoint(img, steps.getVectorData(), params[0]);
				}
				return false;

			case ParameterSetting.PARAM_TYPE_MEASURE_TRIM:
				// 摜v ؂o
				if (param instanceof SteppingParameter) {
					SteppingParameter steps = (SteppingParameter) param;
					return ProcessMeasureTrim(img, steps.getStepCount());
				}
				return false;

			case ParameterSetting.PARAM_TYPE_MEASURE_SCALE:
				// 摜v gk
				return ProcessMeasureScale(img, params[0]);

			case ParameterSetting.PARAM_TYPE_MEASURE_SHARP:
				// 摜v א
				if (param instanceof SteppingParameter) {
					SteppingParameter steps = (SteppingParameter) param;
					return ProcessMeasureThinning(img, steps.getStepCount(), params[0]);
				}
				return false;

			case ParameterSetting.PARAM_TYPE_MEASURE_AREA:
				// 摜v ʐ
				if (param instanceof SteppingParameter) {
					SteppingParameter steps = (SteppingParameter) param;
					return ProcessMeasureArea(img, steps);
				}
				return false;
			
			case ParameterSetting.PARAM_TYPE_ANALYZE_FOURIER:
				// 摜 t[GWJ
				if (params.length < 2) return false;
				return ProcessAnalyzeFourier(img, params[0], params[1]);
				
			case ParameterSetting.PARAM_TYPE_DESCRIPT_PROJECTION:
				// 摜 e
				if (params.length < 2) return false;
				return ProcessAnalyzeProjection(img, params[0], params[1]);
			
			case ParameterSetting.PARAM_TYPE_DESCRIPT_REFLECTANCE:
				// 摜 
				if (params.length < 8) return false;
				return ProcessAnalyzeReflectance(img, params);
			}
		}
		return false;
	}

	private static boolean ProcessContrast(GrpSimBuffer img, int nContrast) {
		if (nContrast<-10 || nContrast>10) return false;
		TransContrast filer = new TransContrast();
		int[] param = new int[1];
		param[0] = nContrast;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessHighPass(GrpSimBuffer img, int nStartLevel) {
		if (nStartLevel<0 || nStartLevel>100) return false;
		TransHighPass filer = new TransHighPass();
		int[] param = new int[1];
		param[0] = nStartLevel;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessHighCut(GrpSimBuffer img, int nStartLevel) {
		if (nStartLevel<0 || nStartLevel>100) return false;
		TransHighCut filer = new TransHighCut();
		int[] param = new int[1];
		param[0] = nStartLevel;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessLabeling(GrpSimBuffer img, int nNumOfPhases) {
		if (nNumOfPhases<1 || nNumOfPhases>255) return false;
		TransFloorQuantum filer = new TransFloorQuantum();
		int[] param = new int[1];
		param[0] = nNumOfPhases;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessDensityLine(GrpSimBuffer img, int nNumOfPhases) {
		if (nNumOfPhases<1 || nNumOfPhases>100) return false;
		TransConcentLine filer = new TransConcentLine();
		int[] param = new int[1];
		param[0] = nNumOfPhases;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessLevelChange(GrpSimBuffer img, int nBottomLevel, int nTopLebel) {
		if (nBottomLevel<0 || nBottomLevel>49 || nTopLebel<50 || nTopLebel>100) return false;
		TransDynamicExpnd filer = new TransDynamicExpnd();
		int[] param = new int[2];
		param[0] = nBottomLevel;
		param[1] = nTopLebel;
		filer.Filter(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	// 3 * 3
	private static boolean ProcessShowEdge(GrpSimBuffer img, int nFilter[]) {
		NeighborOp filer = new NeighborOp(3, nFilter, 1);
		filer.Filter(0, img);
		// RGBύX̂YUVύXB
		img.syncDst(img.RGB);
		return true;
	}

	private static boolean ProcessSmoothing(GrpSimBuffer img, int nFilter[]) {
		int ndiv = 0;
		for (int i = 0; i < 9; i ++) {
			ndiv += nFilter[i];
		}
		NeighborOp filer = new NeighborOp(3, nFilter, ndiv);
		filer.Filter(0, img);
		// RGBύX̂YUVύXB
		img.syncDst(img.RGB);
		return true;
	}

	private static boolean ProcessRemoveNoise(GrpSimBuffer img, int nFilter[]) {
		int ndiv = 0;
		for (int i = 0; i < 9; i ++) {
			ndiv += nFilter[i];
		}
		NeighborOp filer = new NeighborOp(3, nFilter, ndiv);
		filer.Filter(0, img);
		// RGBύX̂YUVύXB
		img.syncDst(img.RGB);
		return true;
	}

	private static boolean ProcessEmphasis(GrpSimBuffer img, int nFilter[]) {
		NeighborOp filer = new NeighborOp(3, nFilter, 1);
		filer.Filter(0, img);
		// RGBύX̂YUVύXB
		img.syncDst(img.RGB);
		return true;
	}

	// qXgO
	private static boolean ProcessHistogramPrint(GrpSimBuffer img, int nSelected[]) {
		HistogramOp filter = new HistogramOp();
		filter.printHist(filter.YP, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), nSelected);
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}

	private static boolean ProcessHistogramNormal(GrpSimBuffer img, int nSelected[]) {
		HistogramFlat filter = new HistogramFlat();
		filter.Calculation(filter.YP, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), nSelected);
		//filter.Normal(filter.YP, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
		// YUVύX̂RGBύXB
		img.syncDst(img.YUV);
		return true;
	}
	private static boolean ProcessHistogramBinary(GrpSimBuffer img, int nIkiti) {
		HistogramBinary filter = new HistogramBinary();
		int param[] = new int [1];
		param[0] = nIkiti;
		filter.Calculation(img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), param);
	    // YUVύX̂RGBύXB
	    img.syncDst(img.YUV);
		return true;
	}
	
	// f[^\ F
	/** 摜f[^\ _
	 * @param img 摜ǗNX
	 * @param rgb 肵F
	 * @return IȂtrue
	 */
	private static boolean ProcessFillRGB(GrpSimBuffer img, int rgb) {
		BufferedImage imgRGB = img.getDstImage(GrpSimBuffer.RGB);
		int w = imgRGB.getWidth();
		int h = imgRGB.getHeight();
		int[] tmp = new int[w * h];
		java.util.Arrays.fill(tmp,0xFF000000|rgb);
		imgRGB.setRGB(0,0,w,h,tmp,0,1);
		// RGBύX̂YUVύXB
		img.syncDst(img.RGB);
		return true;
	}
	// f[^\_
	/** 摜f[^\ _
	 * @param img	摜ǗNX
	 * @param gsdd	Drawf[^
	 * @param nZoom	gk(p[Zg)
	 * @return IȂtrue
	 */
	private static boolean ProcessDescriptPoint(GrpSimBuffer img, GrpSimVectorData gsvd, int nZoom) {
		BufferedImage imgSrc = img.getSrcImage(GrpSimBuffer.RGB);
		BufferedImage imgBuf = new BufferedImage(imgSrc.getWidth(), imgSrc.getHeight(), BufferedImage.TYPE_INT_ARGB);
		// srcɉ摜WJ
		int w = imgSrc.getWidth();
		int h = imgSrc.getHeight();
		int[] tmp = new int[w * h];
		java.util.Arrays.fill(tmp,0xFFFFFFFF);
		imgBuf.setRGB(0,0,w,h,tmp,0,1);
		gsvd.write(imgBuf);
		// resize
		imgBuf = resize(imgBuf, nZoom);
		imgBuf.copyData(imgSrc.getRaster());
		// RGBύX
		img.syncSrc(img.RGB);
		
		// Dstɐf[^̂gkĕ`悷
		// ofsʂvZ
		int ofx = - (((nZoom * 160) / 100) - 160);
		int ofy = - (((nZoom * 120) / 100) - 120);
		img.getDstImage(GrpSimBuffer.RGB).setRGB(0,0,w,h,tmp,0,1);
		gsvd.write(img.getDstImage(GrpSimBuffer.RGB), nZoom, ofx, ofy);
		// RGBύX
		img.syncDst(img.RGB);
		
		return true;
	}
	
	/** 摜obt@TCY
	 * @param img	摜obt@
	 * @param nZoom	gk(p[Zg)
	 * @return TCỶ摜obt@
	 */
	private static BufferedImage resize(BufferedImage img, int nZoom) {
		if (nZoom < 1) nZoom = 1;
		int w = img.getWidth();
		int h = img.getHeight();
		int newW = w * nZoom / 100;
		int newH = h * nZoom / 100;

		BufferedImage after = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
		int[] tmp = new int[w * h];
		java.util.Arrays.fill(tmp,0xFFFFFFFF);
		after.setRGB(0,0,w,h,tmp,0,1);		
		
		Graphics2D graphics = after.createGraphics();
		Image resized = img.getScaledInstance(newW, newH, Image.SCALE_FAST);
		graphics.drawImage(resized, (w - newW) / 2 , (h - newH) / 2, null);
		graphics.dispose();

		return after;
	}
	
	// 摜v ؂o
	static MeasureTrim mt_ = null;
	/** 摜v؂o ֐
	 * @param img 摜ǗNX
	 * @param nStepCount  p^
	 * @return IȂtrue
	 */
	private static boolean ProcessMeasureTrim(GrpSimBuffer img, int nStepCount) {
		// 摜v ؂o
		//System.out.println("Step Test : " + nStepCount);	// debug
		if (mt_ == null) 
			mt_ = new MeasureTrim();
		if (nStepCount == 1) {
			// lf[^쐬
			mt_.makeWB(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// vZ
			mt_.init(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
		} else if (nStepCount == 0) {
			// ɖ߂
			if (mt_ != null) {
				//while (mt_.checkCalcEnd()) {
					// 1Steps
				//	mt_.calcStep();
				//}
				mt_ = null;
			}
		} else if (nStepCount < 0) {
			// Ō܂Ŏs
			while (mt_.checkCalcEnd()) {
				// 1Steps
				mt_.calcStep();
			}
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// J
			mt_ = null;
		} else {
			// 1Steps
			mt_.calcStep();
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
		}
		return true;
	}

	// 摜v א
	static MeasureThinning mth_ = null;
	/** 摜v א ֐
	 * @param img 摜ǗNX
	 * @param nStepCount  p^
	 * @param nHigeMax	qQ(nStepCount1̂ƂӖ)
	 * @return IȂtrue
	 */
	private static boolean ProcessMeasureThinning(GrpSimBuffer img, int nStepCount, int nHigeMax) {
		// 摜v ؂o
		//System.out.println("Step Test : " + nStepCount);	// debug
		if (mth_ == null) 
			mth_ = new MeasureThinning();
		if (nStepCount == 1) {
			// lf[^쐬
			mth_.makeWB(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// vZ
			mth_.init(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV), nHigeMax);
		} else if (nStepCount == 0) {
			// ɖ߂
			if (mth_ != null) {
				//while (mth_.checkCalcEnd()) {
					// 1Steps
				//	mth_.calcStep();
				//}
				mth_ = null;
			}
		} else if (nStepCount < 0) {
			// Ō܂Ŏs
			while (mth_.checkCalcEnd()) {
				// 1Steps
				mth_.calcStep();
			}
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// J
			mth_ = null;
		} else {
			// 1Steps
			mth_.calcStep();
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
		}
		return true;
	}
	
	// 摜v ʐ
	static MeasureArea mA_ = null;
	/** 摜v؂o ֐
	 * @param img 摜ǗNX
	 * @param steps  p^
	 * @return IȂtrue
	 */
	private static boolean ProcessMeasureArea(GrpSimBuffer img, SteppingParameter steps) {
		// 摜v ؂o
		//System.out.println("Step Test : " + nStepCount);	// debug
		int nStepCount = steps.getStepCount();
		if (mA_ == null) 
			mA_ = new MeasureArea();
		if (nStepCount == 1) {
			// lf[^쐬
			mA_.makeWB(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// vZ
			mA_.init(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
		} else if (nStepCount == 2) {
			// xO
			mA_.labeling();
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
		} else if (nStepCount == 0) {
			// ɖ߂
			if (mA_ != null) {
				//while (mA_.checkCalcEnd()) {
					// 1Steps
				//	mA_.calcStep();
				//}
				mA_ = null;
			}
		} else if (nStepCount < 0) {
			// Ō܂Ŏs
			while (mA_.checkCalcEnd()) {
				// 1Steps
				mA_.calcStep();
			}
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			// ʐς̈ꗗo͂
			steps.setStepResult(mA_.getArea());
			// J
			mA_ = null;
		} else {
			// 1Steps
			mA_.calcStep();
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
		}
		return true;
	}
	/** 摜v gk̏
	 * @param img GrpSim摜obt@NX
	 * @param nAction	e
	 * @return IȂtrue
	 */
	private static boolean ProcessMeasureScale(GrpSimBuffer img, int nAction) {
		MeasureScale ms = new MeasureScale();
		// YUVł
		ms.action(0, nAction, img.getSrcImage(img.YUV), img.getDstImage(img.YUV));
	    // YUVύX̂RGBύXB
	    img.syncDst(img.YUV);
		return true;
	}
	
	// 摜F
	static AnalyzeFourier af_ = new AnalyzeFourier();
	/** 摜F t[GWJ
	 * @param img GrpSim摜obt@NX
	 * @param nAction	e
	 * @param nCutOff	Ւf
	 * @return IȂtrue
	 */
	private static boolean ProcessAnalyzeFourier(GrpSimBuffer img, int nAction, int nCutOff) {
		switch (nAction) {
		case 1:
			// l E
			af_.makeWB(0, img.getSrcImage(GrpSimBuffer.YUV), img.getDstImage(GrpSimBuffer.YUV));
			// YUVύX̂RGBύXB
			img.syncDst(img.YUV);
			af_.init(0, img.getSrcImage(GrpSimBuffer.YUV));
			// 摜`
			af_.writeSrcDiag(img.getDstImage(GrpSimBuffer.RGB));
			// RGBύX̂YUVύXB
			img.syncDst(img.RGB);
			return true;
		case 2:
			// vZ
			af_.calcPFFT(nCutOff);
			// `
			af_.writeFFTDiag(img.getDstImage(GrpSimBuffer.RGB));
			// RGBύX̂YUVύX			
			img.syncDst(img.RGB);
			return true;
		default:
			return false;
		}
	}
	
	/** 摜F e
	 * @param img GrpSim摜obt@NX
	 * @param nProj		eʂ̈ʒu
	 * @param nCame		_̈ʒu
	 * @return IȂtrue
	 */
	private static boolean ProcessAnalyzeProjection(GrpSimBuffer img, int nProj, int nCame) {
		AnalyzeProjection ap = new AnalyzeProjection();
		// \[X摜Ƀp
		ap.Parallel(img.getSrcImage(GrpSimBuffer.RGB), (double)nCame, (double)nProj);
		img.syncSrc(GrpSimBuffer.RGB);
		// Dst摜Ƀp[XyNeBu
		ap.Perspective(img.getDstImage(GrpSimBuffer.RGB), (double)nCame, (double)nProj);
		img.syncDst(GrpSimBuffer.RGB);
		return true;
	}

	/** 摜F tN^X
	 * @param img GrpSim摜obt@NX
	 * @param nPrams	p^8
	 * @return IȂtrue
	 */
	private static boolean ProcessAnalyzeReflectance(GrpSimBuffer img, int[] nParams) {
		AnalyzeReflectance ar = new AnalyzeReflectance(GrpSim.res_);
		// \[X摜Face
		ar.faceColor(img.getSrcImage(GrpSimBuffer.RGB), nParams[0], nParams[1], nParams[2], nParams[3], nParams[4], nParams[5], nParams[6], nParams[7]);
		img.syncSrc(GrpSimBuffer.RGB);
		// Dst摜Sphere
		ar.sphere(img.getDstImage(GrpSimBuffer.RGB), nParams[0], nParams[1], nParams[2], nParams[3], nParams[4], nParams[5], nParams[6], nParams[7]);
		img.syncDst(GrpSimBuffer.RGB);
		return true;
	}
}

