package jp.ac.nime.computer.grpsimulator.ImgPr;

import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.util.*;
/** 摜 t[GWJ
 * @author Kikuchi
 * @see FFT
 * @see Complex
 * @see ComplexF
 */
public class AnalyzeFourier {
	// NXϐ
	private int nWidth_;
	private int nHeight_;
	protected int nOp_;
	protected BufferedImage imgSrc_;
	protected BufferedImage imgDst_;
	protected int[] nBorder_;
	// 摜ŕ\}`
	private Diag diag_;
	// FFTň񈳏kWJŕ\}`
	private Diag diagFFT_;
	// fftpf[^obt@
	private int[] numFFT_;
	private ComplexF[] fft_;
	/** _\NX
	 */
	class XY {
		public XY(int x, int y) {
			x_ = x;
			y_ = y;
		}
		public int x_, y_;
	}
	/** \NX
	 */
	class Line {
		private Vector v_;
		public Line() {
			v_ = new Vector(0, 100);
		}
		public void add(int x, int y) {
			v_.add(new XY(x, y));
		}
		public XY get(int n) {
			if (n >= v_.size()) return null;
			return (XY)v_.get(n);
		}
		public int size() {
			return v_.size();
		}
		public void delTail() {
			v_.remove(v_.size() - 1);
		}
		public void clr() {
			v_.clear();
		}
	}
	
	/** ̉(}`)\NX
	 */
	class Diag {
		private Vector v_;
		public Diag() {
			v_ = new Vector();
		}		
		public void add(Line l) {
			v_.add(l);
		}
		public Line get(int n) {
			if (n >= v_.size()) return null;
			return (Line)v_.get(n);
		}
		public int size() {
			return v_.size();
		}
		public void delTail() {
			v_.remove(v_.size() - 1);
		}
		public void clr() {
			for (int i = 0; i < v_.size(); i ++) {
				get(i).clr();
			}
			v_.clear();
		}
	}
	
	/** RXgN^
	 */
	public AnalyzeFourier() {
		diag_ = new Diag();
		diagFFT_ = new Diag();
	}
	
	/** 摜쐬
	 * @param flag	1̂Ƃ]
	 * @param imgSrc	YUV`摜
	 * @param imgDst	YUV`摜
	 */
	public static void makeWB(int flag, BufferedImage imgSrc, BufferedImage imgDst) {
		MeasureOp.makeWhiteBlack(flag, imgSrc, imgDst);
	}
	
	/** vZɕKvȃp^ݒ (̃NXƈďo͂RGB`摜n)
	 * @param nOp	0:Ώۂ 1:Ώۂ
	 * @param imgSrc	YUV`摜(lĂ邱ƂO)
	 */
	public void init(int nOp, BufferedImage imgSrc) {
		// L
		imgSrc_ = imgSrc;
		nWidth_ = imgSrc_.getWidth();
		nHeight_ = imgSrc_.getHeight();
		// f[^쐬ɎgEf[^
		nBorder_ = new int [nWidth_ * nHeight_];
		Arrays.fill(nBorder_, 0);
		// f[^𐶐
		makeDiag();
		// FFTpobt@
		numFFT_ = new int [diag_.size()];
		fft_ = new ComplexF[32768];
		for (int i = 0; i < fft_.length; i ++) {
			fft_[i] = new ComplexF(0.0, 0.0);
		}
//System.out.println("SrcDiag = " + diag_.size() + " lines");
	}
	
	
	/** P`t[GϊEtϊ
	 */
	public void calcPFFT(int nCutOff) {
		// 2̗ݏ̃f[^
		int[] rui2 = new int [16];
		rui2[0] = 1;
		for (int i = 1; i < 16; i++) {
			rui2[i] = (int)Math.pow(2, i);
		}
		// ƂɃt[Gϊ -> LowPass -> tϊ -> V Jւ[v
		diagFFT_.clr();
		for (int i = 0; i < diag_.size(); i ++) {
			// FFTpf[^̌
			int nPoint = diag_.get(i).size();
			int nFFT = 0;
			for (int j = 1; j < 16; j ++) { // 32768 ܂őΉ
				if (nPoint <= rui2[j]) {
					nFFT = rui2[j];
					break;
				}
			}
//System.out.println("SrcDiag Line(" + i + ") = " + nPoint + " points");
			// FFTp̃f[^쐬
			double[] dbDiff = new double[nPoint - 1]; // _Ɠ_̊Ԃ̋
			for (int k = 0; k < nFFT; k ++) {
				fft_[k].set(0, 0); // vZɕKv̓NA
			}			
			for (int k = 0; k < nPoint - 1; k ++) {
				XY xy1 = diag_.get(i).get(k);
				XY xy2 = diag_.get(i).get(k + 1);
				dbDiff[k] = Math.sqrt(((xy1.x_ - xy2.x_) * (xy1.x_ - xy2.x_)) + ((xy1.y_ - xy2.y_) * (xy1.y_ - xy2.y_)));
				// 1data
				fft_[k].set((xy2.x_ - xy1.x_) / dbDiff[k], (xy2.y_ - xy1.y_) / dbDiff[k]);
			}
			// t[Gϊ
			FFT.fft(1, fft_, nFFT);
			// LowPass
			for (int k = nCutOff + 1; k < nFFT - nCutOff; k ++) {
				fft_[k].set(0, 0);
			}
			// tϊ
			FFT.fft(-1, fft_, nFFT);
			
			// V쐬
			Line line = new Line();
			// n_
			XY xy0 = diag_.get(i).get(0);
			line.add(xy0.x_, xy0.y_);
			for (int k = 0; k < nPoint - 1; k ++) {
				// V_쐬
				int x = (int)((line.get(k).x_ + dbDiff[k] * fft_[k].getReal()) + 0.5);
				int y = (int)((line.get(k).y_ + dbDiff[k] * fft_[k].getImag()) + 0.5);
				line.add(x, y);
			}
			// }`ɓo^
			diagFFT_.add(line);
		}
//System.out.println("FFTDiag = " + diagFFT_.size() + " lines");
	}

	/** }``悷
	 * @param diag }`
	 * @param img  }``悷摜obt@(RGB`)
	 */
	private static void writeDiag(Diag diag, BufferedImage img) {
		Graphics2D g = img.createGraphics();
		// ŃNA
		g.setBackground(Color.white);
		g.clearRect(0, 0, 320, 240);
		g.setStroke(new BasicStroke(0.0f)); // ԍׂ float
		g.setPaint(Color.black); // 
		// }`
		for (int i = 0; i < diag.size(); i ++) {
			// ̃[v
			Line line = diag.get(i);
			for (int k = 0; k < line.size() - 1; k ++) {
				// ̃C
				g.draw(new Line2D.Double(line.get(k).x_, line.get(k).y_, line.get(k + 1).x_, line.get(k + 1).y_));
			}
		}
	    g.dispose();
	}

	/** FFTWJvZ̐V}``悷
	 * @param img 摜o͐(RGB`ł邱)
	 */
	public void writeFFTDiag(BufferedImage img) {
		writeDiag(diagFFT_, img);
	}

	/** }`(E)`悷
	 * @param img 摜o͐(RGB`ł邱)
	 */
	public void writeSrcDiag(BufferedImage img) {
		writeDiag(diag_, img);
	}

	
	/** }`؂oāAf[^𐶐
	 */		
	private int makeDiag() {
		diag_.clr();
		// n_̌
		for (int y = 0; y < nHeight_; y ++) {
			for (int x = 0; x < nWidth_; x ++) {
				// ړ_Lf[^n_Ƃ
				if ((getPointData(x, y) == 1) && (nBorder_[x + (y * nWidth_)] == 0)) {
					// OE or E
					if (getPointData(x - 1, y) == 0) {
						Line line = new Line();
						// OET
						chase8(x, y, 7, line);
						// ǉ
						diag_.add(line);
					} else if (getPointData(x + 1, y) == 0) {
						Line line = new Line();
						// ET
						chase8(x, y, 3, line);
						// ǉ
						diag_.add(line);
					}
				}
			}
		}
		return 0;
	}
		
	/** 8ATȂf[^擾
	 * @param x	n_x
	 * @param y n_y
	 * @param nChase ŏ̒T
	 * @param line o̊i[
	 */
	private void chase8(int x, int y, int nChase, Line line) {
		int x0 = x, y0 = y;
		int x1, y1, x2, y2;
		boolean chk;	// Tł݂
		XY xy;
		// 
		x1 = x0; y1 = y0;
		x2 = -1; y2 = -1;
		chk = false;
		// n_L
		line.add(x0, y0);
		// T[v WɋAĂ܂ł̃[v
		while ((x2 != x0) || y2 != y0) {
			chk = false;
			switch (nChase) {
			case 0:		// T
				x2 = x1;
				y2 = y1 + 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 6;
					chk = true;
				} else {
					// 
					nChase = 1;
				}
				break;
			case 1:		// E
				x2 = x1 + 1;
				y2 = y1 + 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 7;
					chk = true;
				} else {
					// 
					nChase = 2;
				}
				break;
			case 2:		// E
				x2 = x1 + 1;
				y2 = y1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 0;
					chk = true;
				} else {
					// 
					nChase = 3;
				}
				break;
			case 3:		// E
				x2 = x1 + 1;
				y2 = y1 - 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 1;
					chk = true;
				} else {
					// 
					nChase = 4;
				}
				break;
			case 4:		// 
				x2 = x1;
				y2 = y1 - 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 2;
					chk = true;
				} else {
					// 
					nChase = 5;
				}
				break;
			case 5:		// 
				x2 = x1 - 1;
				y2 = y1 - 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 3;
					chk = true;
				} else {
					// 
					nChase = 6;
				}
				break;
			case 6:		// 
				x2 = x1 - 1;
				y2 = y1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 4;
					chk = true;
				} else {
					// 
					nChase = 7;
				}
				break;
			case 7:		// 
				x2 = x1 - 1;
				y2 = y1 + 1;					
				if (getPointData(x2, y2) == 1) {
					// 
					nChase = 5;
					chk = true;
				} else {
					// 
					nChase = 0;
				}
				break;
			}
			// xO
			if (chk) {
				// L
				nBorder_[x2 + y2 * nWidth_] = 1;
				line.add(x2, y2);
				// Wړ
				x1 = x2;
				y1 = y2;
			}
		}
		// ̏Ԃ n_ƏI_vĂB
		// vector̍ŌɏI_Ă̂Ŏ菜
		line.delTail();
	}
	
	/**
	 * 摜̎wʒűߖTf[^(3x3)o͂
	 * o̓f[^́AΏۂɂĔfB
	 * L_A1ɂȂBL_A0B
	 * ̈ÓA 0 ɂȂB
	 * imgSrc_Ώۉ摜B
	 * 
	 * @param ptx	f[^~SWx
	 * @param pty	f[^~SWy
	 * @return Ώۃf[^1Ƃf[^ ȊO 0
	 */
	private int[] getNearPointData(int ptx, int pty) {
		return getNearPointData(imgSrc_, 3, ptx, pty);
	}
	
	/**
	 * 摜̎wʒűߖTf[^o͂
	 * o̓f[^́AΏۂɂĔfB
	 * L_A1ɂȂBL_A0B
	 * ̈ÓA 0 ɂȂB
	 * @param img	摜f[^
	 * @param nN	ߖTf[^̋`TCY(3x3Ȃ 3w)
	 * @param ptx	f[^~SWx
	 * @param pty	f[^~SWy
	 * @return Ώۃf[^1Ƃf[^ ȊO 0
	 */
	private int[] getNearPointData(BufferedImage img, int nN, int ptx, int pty) {
		// ߂ll
		int[] result = new int[nN * nN];
		// 
		for (int i = 0; i < result.length; i++) result[i] = 0;
		// f[^擾
		int nHalf = nN / 2;
		for (int y = 0; y < nN; y++) {
			int iy = pty + y - nHalf;
			if (iy < 0 || iy >= img.getHeight()) continue;
			for (int x = 0; x < nN; x++) {
				int ix = ptx + x - nHalf;
				if (ix < 0 || ix >= img.getWidth()) continue;
				int yy = (img.getRGB(ix,iy) & 0x00FF0000) >> 16; // Px
				int a = (img.getRGB(ix,iy) & 0xFF000000) >> 24; // alpha
				if (a != 0) {
					if (nOp_ == 0) { // Ώ
						// Ώۂ 
						if (yy < 128) {
							result[x + y * nN] = 1;
						} else {
							result[x + y * nN] = 0;
						}
					} else {
						// Ώۂ 
						if (yy < 128) {
							result[x + y * nN] = 0;
						} else {
							result[x + y * nN] = 1;
						}
					}
				} else {
					// ̈O
					result[x + y * nN] = 0;
				}
			}
		}
		return result;
	}
		
	/**
	 * 摜̎wʒu̓_Ώۃf[^A1Ԃ
	 * ̈ÓA 0 ɂȂB
	 * imgSrc_Ώۉ摜
	 * 
	 * @param ptx	f[^~Wx
	 * @param pty	f[^~Wy
	 * @return Ώۃf[^1Ƃf[^ ȊO 0
	 */
	private int getPointData(int ptx, int pty) {
		return getPointData(imgSrc_, ptx, pty);
	}
	
	/**
	 * 摜̎wʒu̓_Ώۃf[^A1Ԃ
	 * ̈ÓA 0 ɂȂB
	 * @param img	Ώۉ摜f[^
	 * @param ptx	f[^~Wx
	 * @param pty	f[^~Wy
	 * @return Ώۃf[^1Ƃf[^ ȊO 0
	 */
	private int getPointData(BufferedImage img, int ptx, int pty) {
		// ͈̓`FbN
		if (ptx < 0 || ptx >= img.getWidth()) return 0;
		if (pty < 0 || pty >= img.getHeight()) return 0;
		// Pxf[^	
		int yy = (img.getRGB(ptx,pty) & 0x00FF0000) >> 16; // Px
		int a = (img.getRGB(ptx,pty) & 0xFF000000) >> 24; // alpha
		int result = 0;
		if (a != 0) {
			if (nOp_ == 0) { // Ώ
				// Ώۂ 
				if (yy < 128) {
					result = 1;
				} else {
					result = 0;
				}
			} else {
				// Ώۂ 
				if (yy < 128) {
					result = 0;
				} else {
					result = 1;
				}
			}
		} else {
			// ̈O
			result = 0;
		}
		return result;
	}
}
