package jp.ac.nime.computer.grpsimulator.ImgPr;

import java.awt.*;
import java.awt.image.*;
import java.util.*;

/** 摜v gk(cEk)
 * @author Kikuchi
 * @version 1.0.0
 */
public class MeasureScale {
	
	// ew
	public static final int WHITEBLACK	= 0;
	public static final int EXPAND4		= 1;
	public static final int CONTRACT4	= 2;
	public static final int EXPAND8		= 3;
	public static final int CONTRACT8	= 4;
		
	/** ckvZ
	 * @param nOp	0:Ώۂ 1:Ώۂ (nAction==WHITEBLACK̂Ƃ 1̂Ƃ])
	 * @param nAction e WHITEBLACK:l EXPAND4:4Ag CONTRACT4:4Ak EXPAND8:8Ag CONTRACT8:8Ak
	 * @param imgSrc	YUV`摜
	 * @param imgDst	YUV`摜
	 */
	public static boolean action(int nOp, int nAction, BufferedImage imgSrc, BufferedImage imgDst) {
		switch (nAction) {
		case WHITEBLACK:
			WhiteBlackOp.Calculation(nOp, imgSrc, imgDst);
			return true;
		case EXPAND4:
			expand(0, nOp, imgSrc, imgDst);
			return true;
		case CONTRACT4:
			contract(0, nOp, imgSrc, imgDst);
			return true;
		case EXPAND8:
			expand(1, nOp, imgSrc, imgDst);
			return true;
		case CONTRACT8:
			contract(1, nOp, imgSrc, imgDst);
			return true;
		}
		return false;
	}
	
	/** g(c)
	 * @param flag		0:lA 1:A 
	 * @param nOp		Ώ 0:Ώۂ 1:Ώۂ
	 * @param imgSrc	YUV`摜
	 * @param imgDst	YUV`摜
	 */
	private static void expand(int flag, int nOp, BufferedImage imgSrc, BufferedImage imgDst) {
		for (int y = 0; y < imgSrc.getHeight(); y ++) {
			for (int x = 0; x < imgSrc.getWidth(); x ++) {
				// ߖTf[^擾
				int op[] = getNearPointData(nOp, imgSrc, x, y);
				// ړ_Ώۃf[^łȂ珈
				if (op[4] == 0) { 
					int c = 0; // e
					if (flag == 0) {
						// lA
						c = op[1] + op[3] + op[5] + op[7];
					} else {
						// A
						c = op[0] + op[1] + op[2] + op[3] + op[5] + op[6] + op[7] + op[8];
					}
					if (c > 0) { // ̕Kv
						int yuv;
						if (nOp == 0) {
							yuv = WhiteBlackOp.MakeWByuv(0); // 
						} else {
							yuv = WhiteBlackOp.MakeWByuv(255);  // 
						}
						yuv |= 0xff000000;
						imgDst.setRGB(x, y, yuv);
					}
				}
			}
		}
	}
	
	/** k(k)
	 * @param flag		0:lA 1:A 
	 * @param nOp		Ώ 0:Ώۂ 1:Ώۂ
	 * @param imgSrc	YUV`摜
	 * @param imgDst	YUV`摜
	 */
	private static void contract(int flag, int nOp, BufferedImage imgSrc, BufferedImage imgDst) {
		for (int y = 0; y < imgSrc.getHeight(); y ++) {
			for (int x = 0; x < imgSrc.getWidth(); x ++) {
				// ߖTf[^擾
				int op[] = getNearPointData(nOp, imgSrc, x, y);
				// ړ_Ώۃf[^珈
				if (op[4] == 1) { 
					int c = 0; // e
					if (flag == 0) {
						// lA
						if (op[1] == 0 || op[3] == 0 || op[5] == 0 || op[7] == 0) {
							c = 1;
						}
					} else {
						// A
						if (op[0] == 0 || op[1] == 0 || op[2] == 0 || op[3] == 0 || op[5] == 0 || op[6] == 0 || op[7] == 0 || op[8] == 0) {
							c = 1;
						}
					}
					if (c > 0) { // ̕Kv
						int yuv;
						if (nOp == 0) {
							yuv = WhiteBlackOp.MakeWByuv(255);  // 
						} else {
							yuv = WhiteBlackOp.MakeWByuv(0);    // 
						}
						yuv |= 0xff000000;
						imgDst.setRGB(x, y, yuv);
					}
				}
			}
		}
	}

	
	/**
	 * 摜̎wʒűߖTf[^(NxN)o͂
	 * o̓f[^́AΏۂɂ
	 * ̈ÓA 0 ɂȂB
	 * 
	 * @param nOp	0:Ώۂ 1:Ώۂ
	 * @param imgSrc	Ώۉ摜
	 * @param ptx	f[^~SWx
	 * @param pty	f[^~SWy
	 * @return Ώۃf[^1Ƃf[^ ȊO 0
	 */
	private static int[] getNearPointData(int nOp, BufferedImage imgSrc, int ptx, int pty) {
		// ߂ll
		int nN = 3;
		int result[] = new int[nN * nN];
		// 
		for (int i = 0; i < result.length; i++) result[i] = -1;
		// f[^擾
		int nHalf = nN / 2;
		for (int y = 0; y < nN; y++) {
			int iy = pty + y - nHalf;
			if (iy < 0 || iy >= imgSrc.getHeight()) continue;
			for (int x = 0; x < nN; x++) {
				int ix = ptx + x - nHalf;
				if (ix < 0 || ix >= imgSrc.getWidth()) continue;
				int yy = (imgSrc.getRGB(ix,iy) & 0x00FF0000) >> 16; // Px
				int a = (imgSrc.getRGB(ix,iy) & 0xFF000000) >> 24; // alpha
				if (a != 0) {
					if (nOp == 0) {
						// Ώۂ 
						if (yy < 128) {
							result[x + y * nN] = 1;
						} else {
							result[x + y * nN] = 0;
						}
					} else {
						// Ώۂ 
						if (yy < 128) {
							result[x + y * nN] = 0;
						} else {
							result[x + y * nN] = 1;
						}
					}
				} else {
					// ̈O
					result[x + y * nN] = 0;
				}
			}
		}
		return result;
	}
}
