package jp.ac.nime.computer.grpsimulator.VecPr;

import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.util.*;

/** 摜 tN^X
 * @author Kikuchi
 * @version 1.0.0
 */
public class AnalyzeReflectance {
	// \[X
	ResourceBundle res_;
	/** RXgN^
	 * @param res \[Xnh
	 */
	public AnalyzeReflectance(ResourceBundle res) {
		res_ = res;
	}
	
	/** Fimgɕ\
	 * @param ka (%)
	 * @param kr gU˗R(%)
	 * @param kg gU˗G(%)
	 * @param kb gU˗B(%)
	 * @param ks ʔ˗(%)
	 * @param nn nCCgw
	 * @param ld px(x)(0-180)
	 * @param cd Jpx(x)(0-180)
	 * @return ŏIIȐF
	 */
	public void faceColor(BufferedImage img, int ka, int kr, int kg, int kb, int ks, int nn, int ld, int cd) {
		Graphics2D g = img.createGraphics();
		// ŃNA
		g.setBackground(Color.black);
		g.clearRect(0, 0, img.getWidth(), img.getHeight());
		g.setStroke(new BasicStroke(0.0f)); // ԍׂ float
		// ̕
		int w = img.getWidth() / 4;
		int h = img.getHeight();
		// Fu
		// 
		Color amb = pointAmbient(Color.white, ka, kr, kg, kb);
		g.setColor(amb);
		g.fill(new Rectangle2D.Double(0, 0, w, h));
		// gU
		Color lam = pointLambertReflectance(Color.white, kr, kg, kb, ld); 
		g.setColor(lam);
		g.fill(new Rectangle2D.Double(w, 0, w, h));
		// ʔ
		Color phong = pointPhongReflectance(Color.white, ks, nn, ld, cd);
		g.setColor(phong);
		g.fill(new Rectangle2D.Double(w * 2, 0, w, h));
		// 킹F
		Color all = colplus(amb, lam, phong);
		g.setColor(all);
		g.fill(new Rectangle2D.Double(w * 3, 0, w, h));
		// Řg
		g.setColor(Color.white);
		g.draw(new Rectangle2D.Double(0, 0, w, h));
		g.draw(new Rectangle2D.Double(w, 0, w, h));
		g.draw(new Rectangle2D.Double(w * 2, 0, w, h));
		g.draw(new Rectangle2D.Double(w * 3, 0, w, h));
		// 
		int xs = 10;
		int ys = 20;
		Font font = new Font( "SansSerif", Font.PLAIN, 10 ); 
		g.setFont( font ); 
		g.setColor(Color.white);
		FontMetrics fm = g.getFontMetrics();
		int w2 = fm.stringWidth(res_.getString("DlgAnalyzeReflectanceAmbient"));
		int h2 = fm.getHeight();
		g.fill(new Rectangle2D.Double(xs - 1, ys - h2 + 2, w2, h2));
		w2 = fm.stringWidth(res_.getString("DlgAnalyzeReflectanceLambert"));
		g.fill(new Rectangle2D.Double(xs - 1 + w, ys - h2 + 2, w2, h2));
		w2 = fm.stringWidth(res_.getString("DlgAnalyzeReflectancePhong"));
		g.fill(new Rectangle2D.Double(xs - 1 + w * 2, ys - h2 + 2, w2, h2));
		w2 = fm.stringWidth(res_.getString("DlgAnalyzeReflectanceAll"));
		g.fill(new Rectangle2D.Double(xs - 1 + w * 3, ys - h2 + 2, w2, h2));
		
		g.setColor(Color.black);
		g.drawString(res_.getString("DlgAnalyzeReflectanceAmbient"), xs, ys);
		g.drawString(res_.getString("DlgAnalyzeReflectanceLambert"), xs + w, ys);
		g.drawString(res_.getString("DlgAnalyzeReflectancePhong"), xs + w * 2, ys);
		g.drawString(res_.getString("DlgAnalyzeReflectanceAll"), xs + w * 3, ys);

		g.dispose();
	}
	
	/** imgɕ\
	 * @param ka (%)
	 * @param kr gU˗R(%)
	 * @param kg gU˗G(%)
	 * @param kb gU˗B(%)
	 * @param ks ʔ˗(%)
	 * @param nn nCCgw(Pʂ101)
	 * @param ld px(x)(0-180)
	 * @param cd Jpx(x)(0-180)
	 * @return ŏIIȐF
	 */
	public void sphere(BufferedImage img, int ka, int kr, int kg, int kb, int ks, int nn, int ld, int cd) {
		Graphics2D g = img.createGraphics();
		// ŃNA
		g.setBackground(Color.black);
		g.clearRect(0, 0, img.getWidth(), img.getHeight());
		g.setStroke(new BasicStroke(0.0f)); // ԍׂ float
		// 
		int he = img.getHeight();
		// S
		int cx = img.getWidth() / 2;
		int cy = img.getHeight() / 2;
		// a
		int r = cy * 2 / 3;
		int rr = r * r;
		// 
		Color amb = pointAmbient(Color.white, ka, kr, kg, kb);
		// ւ̃xNg
		double lx = Math.cos((double)ld * Math.PI / 180.0);
		Vertex L = new Vertex(lx, 1, -1);
		L.normal();
		// ւ̃xNg
		Vertex V = new Vertex(0, 0, -1);
		V.normal();
		// ̓_̃[v
		int y;
		int x;
		for (y = -r; y < r; y ++) {
			for (x = - r; x < r; x ++) {
				// aǂ`FbN
				int xxyy = (x * x + y * y);
				if (xxyy <= rr) {
					// F̌
					// z߂
					int zz = Math.abs(rr - xxyy);
					double z2 = - Math.sqrt((double)zz);
					double x2 = x;
					double y2 = y;
					// x, y , z @xNgƌւ̃xNg߂
					Vertex N = new Vertex(x2, y2, z2);
					N.normal();
					// ̐˃xNg
					Vertex R = Vertex.sub(Vertex.scale(N, 2.0 * Vertex.dot(N, L)), L);
					R.normal();
					// gU
					double cos = Vertex.dot(L, N);
//System.out.println("dot(L,N) = " + cos);
					Color lam = pointLambertReflectance(Color.white, kr, kg, kb, cos);
					// ʔ
					cos = Vertex.dot(R, V);
					Color phong = new Color(0, 0, 0);
					if (cos > 0)
						phong = pointPhongReflectance(Color.white, ks, nn, cos);
					// F
					Color all = colplus(amb, lam, phong);
					g.setColor(all);
					g.draw(new Line2D.Double(x + cx, he - (y + cy), x + cx + 1, he - (y + cy)));
				}
			}
		}
		g.dispose();
	}
	
	/** F̑Z
	 * @param amb 
	 * @param lam ˌ
	 * @param phong ʔˌ
	 */
	private Color colplus(Color amb, Color lam, Color phong) {
		int red = amb.getRed() + lam.getRed() + phong.getRed();
		int green = amb.getGreen() + lam.getGreen() + phong.getGreen();
		int blue = amb.getBlue() + lam.getBlue() + phong.getBlue();
		red = Math.max(0, Math.min(255, red));
		green = Math.max(0, Math.min(255, green));
		blue = Math.max(0, Math.min(255, blue));
		return new Color(red, green, blue);
	}
	
	/** 
	 * @param col 
	 * @param ka (%)
	 * @param kr gU˗R(%)
	 * @param kg gU˗G(%)
	 * @param kb gU˗B(%)
	 * @return ːF
	 */
	private Color pointAmbient(Color col, int ka, int kr, int kg, int kb) {
		return new Color((int)((col.getRed() * ka / 100.0 * kr / 100.0) + 0.5),
						 (int)((col.getGreen() * ka / 100.0 * kg / 100.0) + 0.5),
						 (int)((col.getBlue() * ka / 100.0 * kb / 100.0) + 0.5)
						 );
	}
	
	
	/** _̊gU Lambert̗]
	 * @param col 
	 * @param kr gU˗R(%)
	 * @param kg gU˗G(%)
	 * @param kb gU˗B(%)
	 * @param cos Ɩ@cos
	 * @return ːF
	 */
	private Color pointLambertReflectance(Color col, int kr, int kg, int kb, double cos) {
		int red = (int)((col.getRed() * kr * cos / 100.0) + 0.5) ;
		int green = (int)((col.getGreen() * kg * cos / 100.0) + 0.5);
		int blue = (int)((col.getBlue() * kb * cos / 100.0) + 0.5);
//System.out.println("Lam(r, g, b) = " + red + ", " + green + ", " + blue + ", " + cos);
		red = Math.max(0, Math.min(255, red));
		green = Math.max(0, Math.min(255, green));
		blue = Math.max(0, Math.min(255, blue));
		return new Color(red, green, blue);
	}

	/** _̊gU Lambert̗]
	 * @param col 
	 * @param kr gU˗R(%)
	 * @param kg gU˗G(%)
	 * @param kb gU˗B(%)
	 * @param ld px(x)(0-180)
	 * @return ːF
	 */
	private Color pointLambertReflectance(Color col, int kr, int kg, int kb, int ld) {
		int sita = Math.abs(ld - 90);	// @ƂȂp
		double rad = (double)sita * Math.PI/180.0;
		double cos = Math.cos(rad);
		return pointLambertReflectance(col, kr, kg, kb, cos);
	}
	
	
	/** ʔ Phong Reflectance
	 * @param col 
	 * @param ks ʔ˗(%)
	 * @param nn ʎx
	 * @param ld px(x)(0-180)
	 * @param cd _px(x)(0-180)
	 * @return ːF
	 */
	private Color pointPhongReflectance(Color col, int ks, int nn, double cos) {
		double cosn = Math.pow(cos, nn);
		int red = (int)((col.getRed() * ks * cosn / 100.0) + 0.5) ;
		int green = (int)((col.getGreen() * ks * cosn / 100.0) + 0.5);
		int blue = (int)((col.getBlue() * ks * cosn / 100.0) + 0.5);
//System.out.println("Phong(r, g, b) = " + red + ", " + green + ", " + blue);
		red = Math.max(0, Math.min(255, red));
		green = Math.max(0, Math.min(255, green));
		blue = Math.max(0, Math.min(255, blue));
		return new Color(red, green, blue);
	}

	/** ʔ Phong Reflectance
	 * @param col 
	 * @param ks ʔ˗(%)
	 * @param nn ʎx
	 * @param ld px(x)(0-180)
	 * @param cd _px(x)(0-180)
	 * @return ːF
	 */
	private Color pointPhongReflectance(Color col, int ks, int nn, int ld, int cd) {
		// ld, cd  ւ̃xNgƎւ̃xNgƂ̂Ȃpcos߂
		int revld = 180 - ld;	// 
		int ganma = Math.abs(revld - cd); // 
		double rad = (double)ganma * Math.PI/180.0;
		double cos = Math.cos(rad);
		return pointPhongReflectance(col, ks, nn, cos);
	}
	
}