package jp.ac.nime.computer.grpsimulator.VecPr;

import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
/**
 * GrpSimp̍Ww^Cv̉摜f[^\NX
 * Ƌ`Ƒȉ~ō\B
 * @author Kikuchi
 * @version 1.0.0
 */
public class GrpSimVectorData
{
	public static final int DIAGELEM_POLINE = 2;
	public static final String DIAGELEM_POLINE_WORD = "Poline";

	protected Vector v_;	// }`
	
	/** RXgN^
	 */
	public GrpSimVectorData() {
		v_ = new Vector(0, 100);	
	}
	// Cݒ
	public void addPoline(int num, int[] x, int[] y) {
		Poline poline = new Poline();
		for (int i = 0; i < num; i ++) {
			poline.add(x[i], y[i]);
		}
		v_.add(poline);
	}
	
	/** NA
	 */
	public void clr() {
		for (int i = 0; i < v_.size(); i ++) {
			DiagElem de = (DiagElem)v_.get(i);
			de.clr();
		}
		v_.clear();
	}
	
	/** `
	 * @param img `obt@
	 */
	public void write(BufferedImage img) {
		Graphics2D g = img.createGraphics();
		for (int i = 0; i < v_.size(); i ++) {
			DiagElem de = (DiagElem)v_.get(i);
			de.write(g);
		}
		g.dispose();
	}

	/** ` ZoomΉ
	 * @param img `obt@
	 * @param nZoom g嗦(p[Zg)
	 * @param ofx   nZoom̍Woffsetĕ`悷
	 * @param ofy   nZoom̍Woffsetĕ`悷
	 */
	public void write(BufferedImage img, int nZoom, int ofx, int ofy) {
		Graphics2D g = img.createGraphics();
		for (int i = 0; i < v_.size(); i ++) {
			DiagElem de = (DiagElem)v_.get(i);
			de.write(g, nZoom, ofx, ofy);
		}
		g.dispose();
	}
	/** ̔zɂB
	 */
	public String[] toLines() {
		String[] lines = new String[v_.size()];
		for (int i = 0; i < v_.size(); i ++) {
			DiagElem de = (DiagElem)v_.get(i);
			lines[i] = de.toString();
		}
		return lines;
	}
	
	/** f[^ɕϊċL
	 * @param str t@Cǂݍ1linef[^
	 */
	public void add(String str) {
		if (str.startsWith(DIAGELEM_POLINE_WORD)) {
			Poline l = new Poline();
			l.readStr(str);
			v_.add(l);
		}
	}
	
	/** \}`vf̐擾
	 * @return DiagElem̗vf
	 */
	public int size() {
		return v_.size();
	}
	
	/** _\NX
	 */
	public class XY {
		public XY(int x, int y) {
			x_ = x;
			y_ = y;
		}
		public int x_;
		public int y_;
	}

	/** _NX
	 */
	public abstract class DiagElem {
		
		protected Vector	v_;			// _
		protected Color		col_;		// ̕`F
		protected int		thick_;		// ̑

		public DiagElem() {
			v_ = new Vector(0, 100);
			setCol(0, 0, 0);	// 
		}
		public void add(int x, int y) {
			v_.add(new XY(x, y));
		}
		public void setCol(int r, int g, int b) {
			col_ = new Color(r, g, b);
		}
		public int getCol() {
			return col_.getRGB();
		}
		public XY get(int n) {
			if (n >= v_.size()) return null;
			return (XY)v_.get(n);
		}
		public int size() {
			return v_.size();
		}
		public void delTail() {
			v_.remove(v_.size() - 1);
		}
		public void clr() {
			v_.clear();
		}
		/** }`vf̃^Cv擾
		 */
		public abstract int getType();
		/** `
		 * @param g ` Graphics2D 
		 */
		public abstract void write(Graphics2D g);
		/** gk`֐
		 * @param g ` Graphics2D
		 * @param nZoom g嗦(p[Zg)
		 * @param ofx   nZoom̍Woffsetĕ`悷
		 * @param ofy   nZoom̍Woffsetĕ`悷
		 */
		public abstract void write(Graphics2D g, int nZoom, int ofx, int ofy);
		
		/** t@Cɏo̕
		 * @return t@Cɏo̕
		 */
		public abstract String toString();
		
		/** t@CǂݏoƂ̊֐
		 * @param str t@Cǂݏoꂽs
		 * @return 1:  0:̃NXɊY镶łȂ  -1:@G[
		 */
		public abstract int readStr(String str);
		
	}
	public class Poline extends DiagElem {
		/** ł邱ƂԂ
		 */
		public int getType() {
			return DIAGELEM_POLINE;
		}
		/** L[[hԂ
		 */
		public String getKeyword() {
			return DIAGELEM_POLINE_WORD;
		}
		
		/** `
		 * @param g ` Graphics2D 
		 */
		public void write(Graphics2D g) {
			g.setPaint(col_); // F
			// }`
			for (int i = 0; i < (v_.size() - 1); i ++) {
				// ̃C
				XY xy1 = get(i);
				XY xy2 = get(i + 1);
				g.draw(new Line2D.Double(xy1.x_, xy1.y_, xy2.x_, xy2.y_));
			}
		}
		/** gk`֐
		 * @param g ` Graphics2D
		 * @param nZoom g嗦(p[Zg)
		 * @param ofx   nZoom̍Woffsetĕ`悷
		 * @param ofy   nZoom̍Woffsetĕ`悷
		 */
		public void write(Graphics2D g, int nZoom, int ofx, int ofy) {
			g.setPaint(col_); // F
			// }`
			for (int i = 0; i < (v_.size() - 1); i ++) {
				// ̃C
				int x1, y1, x2, y2;
				x1 = (get(i).x_ * nZoom / 100) + ofx;
				y1 = (get(i).y_ * nZoom / 100) + ofy;
				x2 = (get(i + 1).x_ * nZoom / 100) + ofx;
				y2 = (get(i + 1).y_ * nZoom / 100) + ofy;
				g.draw(new Line2D.Double(x1, y1, x2, y2));
			}			
		}
																
		/** t@Cɏo̕
		 * @return t@Cɏo̕
		 */
		public String toString() {
			StringBuffer sb= new StringBuffer();
			String ten = ", ";
			// ŏLineL
			sb.append("Poline ");
			// ɃC̃J[ RGB
			StringBuffer cs = new StringBuffer("00000000");
			cs.append(Integer.toHexString(col_.getRGB()));
			//sb.append("0x");
			sb.append(cs.substring(cs.length() - 6, cs.length()));
			sb.append(ten);
			// ɓ_̐ 
			sb.append(v_.size());
			// ̓_̃f[^
			for (int i = 0; i < v_.size(); i ++) {
				String str = new String(", " + get(i).x_ + ", " + get(i).y_);
				sb.append(str);
			}
			return sb.toString();							 
		}
		/** t@CǂݏoƂ̊֐
		 * @param str t@Cǂݏoꂽs
		 * @return 1:  0:̃NXɊY镶łȂ  -1:@G[
		 */
		public int readStr(String str) {
			// 擪 Polineׂ
			if (!str.startsWith("Poline")) return 0;
			
			clr();	// ŜĂ
			try {
				StringTokenizer st = new StringTokenizer(str.substring(6, str.length()), ",");
				
				// J[f[^o
				int col = Integer.parseInt(st.nextToken().trim(), 16);
				col_ = new Color(col);
				// _̐o
				int numPT = Integer.parseInt(st.nextToken().trim());
				while (st.hasMoreTokens()) {    
					// nextToken() œǂōs
					int x = Integer.parseInt(st.nextToken().trim());
					int y = Integer.parseInt(st.nextToken().trim());
					add(x, y);
				}
			} catch ( Exception e ) {
				System.out.println("Error Poline#readStr");
				e.printStackTrace();
				return -1;
			}
			return 1;
		}
	}
/*
	public class Box extends DiagElem {
		public static final int DIAGELEM_BOX = 3;
	}
	public class Circle extends DiagElem {
		public static final int DIAGELEM_CIRCLE = 4;
	}
*/
}
