package jp.ac.nime.computer.grpsimulator.VecPr;

import java.util.*;

/** _\(xNg)NX
 * @version 1.0.0
 * @author kikuchi
 */
class Vertex {
	public double x_, y_, z_;
	/** RXgN^
	 * @param x Wx
	 * @param y Wy
	 * @param z Wz
	 */
	public Vertex(double x, double y, double z) {
		x_ = x;
		y_ = y;
		z_ = z;
	}
	/** W̕sړ
	 * @param a ړƕ
	 */
	public void movePa(Vertex a) {
		x_ -= a.x_;
		y_ -= a.y_;
		z_ -= a.z_;
	}

	/** Z
	 * @param a N_
	 * @param b I_
	 * @return ̃xNg
	 */
	public static Vertex sub(Vertex a, Vertex b) {
		return new Vertex(a.x_ - b.x_, a.y_ - b.y_, a.z_ - b.z_);
	}
	/** Vectex a ̋N_ b̏I_ւ̃xNgԂ
	 * @param a N_
	 * @param b I_
	 * @return ̃xNg
	 */
	public static Vertex add(Vertex a, Vertex b) {
		return new Vertex(a.x_ + b.x_, a.y_ + b.y_, a.z_ + b.z_);
	}
	/** xNg̊gk
	 * @param a ̃xNg
	 * @param b g嗦
	 * @return ̃xNg
	 */
	public static Vertex scale(Vertex a, double b) {
		return new Vertex(a.x_ * b, a.y_ * b, a.z_ * b);
	}
	
	/** ς߂
	 * @param a xNg
	 * @param b xNg
	 * @return (XJ[)
	 */
	public static double dot(Vertex a, Vertex b) {
		return a.x_ * b.x_ + a.y_ * b.y_ + a.z_ * b.z_;
	}
	/** Oς߂
	 * @param a xNg
	 * @param b xNg
	 * @return O(xNg
	 */
	public static Vertex cross(Vertex a, Vertex b) {
		double x = a.y_ * b.z_ - a.z_ * b.y_;
		double y = a.z_ * b.x_ - a.x_ * b.z_;
		double z = a.x_ * b.y_ - a.y_ * b.x_;
		return new Vertex(x, y, z);
	}
	/** PʃxNg߂
	 * @param a xNg
	 * @return a̒PʃxNg
	 */
	public static Vertex normal(Vertex a) {
		double d = Vertex.length(a);
		double x = a.x_ / d;
		double y = a.y_ / d;
		double z = a.z_ / d;
		return new Vertex(x, y, z);
	}
	
	/** PʃxNgɂ
	 */
	public void normal() {
		double d = 1.0 / Vertex.length(this);
		x_ *= d;
		y_ *= d;
		z_ *= d;
	}
	
	/** 傫(XJ[)߂
	 * @param a xNg
	 * @return ȃ傫
	 */
	public static double length(Vertex a) {
		return Math.sqrt(a.x_ * a.x_ + a.y_ * a.y_ + a.z_ * a.z_);
	}
	
	/** ΂̍s߂
	 * @param a xNg
	 * @return evf]ĂxNg
	 */
	public static Vertex rev(Vertex a) {
		return new Vertex(-a.x_, -a.y_, -a.z_);
	}
	
	/** xNgɍs|
	 * @param v |xNg
	 * @param m |s
	 * @return xNg
	 */
	public static Vertex mul(Vertex v, Matrix m) {
		double[] mm = m.get(); // vf
		double x = v.x_ * mm[0] + v.y_ * mm[4] + v.z_ * mm[8] + mm[12];
		double y = v.x_ * mm[1] + v.y_ * mm[5] + v.z_ * mm[9] + mm[13];
		double z = v.x_ * mm[2] + v.y_ * mm[6] + v.z_ * mm[10] + mm[14];
		return new Vertex(x, y, z);
	}
	/** xNgɍs|
	 * @param m |s
	 */
	public void mul(Matrix m) {
		double[] mm = m.get(); // vf
		this.x_ = this.x_ * mm[0] + this.y_ * mm[4] + this.z_ * mm[8] + mm[12];
		this.y_ = this.x_ * mm[1] + this.y_ * mm[5] + this.z_ * mm[9] + mm[13];
		this.z_ = this.x_ * mm[2] + this.y_ * mm[6] + this.z_ * mm[10] + mm[14];
	}
	/** toString
	 * @return Vertex𕶎ɂ
	 */
	public String toString() {
		return new String( "( " + x_ + ", " + y_ + ", " + z_ + ")");
	}
}

/** lsNX
 * @version 1.0.0
 * @author kikuchi
 */
class Matrix {
	private double m00_, m01_, m02_, m03_;
	private double m10_, m11_, m12_, m13_;
	private double m20_, m21_, m22_, m23_;
	private double m30_, m31_, m32_, m33_;
	/** RXgN^(Pʍs)
	 */
	public Matrix() {
		init();
	}
	/** RXgN^ evfw
	 *  0123
	 *  4567
	 *  89AB
	 *  CDEF
	 * ̏ԂŎw
	 */
	public Matrix(
	  double m00, double m01, double m02, double m03,
	  double m10, double m11, double m12, double m13,
	  double m20, double m21, double m22, double m23,
	  double m30, double m31, double m32, double m33) {
	  m00_ = m00; m01_ = m01; m02_ = m02; m03_ = m03;
	  m10_ = m10; m11_ = m11; m12_ = m12; m13_ = m13;
	  m20_ = m20; m21_ = m21; m22_ = m22; m23_ = m23;
	  m30_ = m30; m31_ = m31; m32_ = m32; m33_ = m33;
	}
	/** RXgN^ evfw
	 *  0123
	 *  4567
	 *  89AB
	 *  CDEF
	 */
	public Matrix(double[] m) {
		if (m.length < 16) {
			init();
			return;
		}
		m00_ = m[ 0]; m01_ = m[ 1]; m02_ = m[ 2]; m03_ = m[ 3];
		m10_ = m[ 4]; m11_ = m[ 5]; m12_ = m[ 6]; m13_ = m[ 7];
		m20_ = m[ 8]; m21_ = m[ 9]; m22_ = m[10]; m23_ = m[11];
		m30_ = m[12]; m31_ = m[13]; m32_ = m[14]; m33_ = m[15];
	} 
	/**@RXgN^ vfRs[
	 * @param m ̎lsNX
	 */
	public Matrix(Matrix m) {
		m00_ = m.m00_; m01_ = m.m01_; m02_ = m.m02_; m03_ = m.m03_;
		m10_ = m.m10_; m11_ = m.m11_; m12_ = m.m12_; m13_ = m.m13_;
		m20_ = m.m20_; m21_ = m.m21_; m22_ = m.m22_; m23_ = m.m23_;
		m30_ = m.m30_; m31_ = m.m31_; m32_ = m.m32_; m33_ = m.m33_;
	}
	
	/** Pʍsɂ
	 */
	public void init() {
		m00_ = 1; m01_ = 0; m02_ = 0; m03_ = 0;
		m10_ = 0; m11_ = 1; m12_ = 0; m13_ = 0;
		m20_ = 0; m21_ = 0; m22_ = 1; m23_ = 0;
		m30_ = 0; m31_ = 0; m32_ = 0; m33_ = 1;
	}
	
	/** vfZbg
	 */
	public void copy(Matrix m) {
		m00_ = m.m00_; m01_ = m.m01_; m02_ = m.m02_; m03_ = m.m03_;
		m10_ = m.m10_; m11_ = m.m11_; m12_ = m.m12_; m13_ = m.m13_;
		m20_ = m.m20_; m21_ = m.m21_; m22_ = m.m22_; m23_ = m.m23_;
		m30_ = m.m30_; m31_ = m.m31_; m32_ = m.m32_; m33_ = m.m33_;
	}
	
	/** vfo
	 */
	public double[] get() {
		double[] m = new double[16];
		m[ 0] = m00_; m[ 1] = m01_; m[ 2] = m02_; m[ 3] = m03_;
		m[ 4] = m10_; m[ 5] = m11_; m[ 6] = m12_; m[ 7] = m13_;
		m[ 8] = m20_; m[ 9] = m21_; m[10] = m22_; m[11] = m23_;
		m[12] = m30_; m[13] = m31_; m[14] = m32_; m[15] = m33_;
		return m;		
	}
	/** s̉Z
	 * @param a z
	 * @param b z
	 */
	public static Matrix add(Matrix a, Matrix b) {
		return new Matrix(a.m00_ - b.m00_, a.m01_ - b.m01_, a.m02_ - b.m02_, a.m03_ - b.m03_, 
						  a.m10_ - b.m10_, a.m11_ - b.m11_, a.m12_ - b.m12_, a.m13_ - b.m13_, 
						  a.m20_ - b.m20_, a.m21_ - b.m21_, a.m22_ - b.m22_, a.m23_ - b.m23_, 
						  a.m30_ - b.m30_, a.m31_ - b.m31_, a.m32_ - b.m32_, a.m33_ - b.m33_);
	}
	/** šZ
	 * @param a z
	 * @param b z
	 */
	public static Matrix sub(Matrix a, Matrix b) {
		return new Matrix(a.m00_ - b.m00_, a.m01_ - b.m01_, a.m02_ - b.m02_, a.m03_ - b.m03_, 
						  a.m10_ - b.m10_, a.m11_ - b.m11_, a.m12_ - b.m12_, a.m13_ - b.m13_, 
						  a.m20_ - b.m20_, a.m21_ - b.m21_, a.m22_ - b.m22_, a.m23_ - b.m23_, 
						  a.m30_ - b.m30_, a.m31_ - b.m31_, a.m32_ - b.m32_, a.m33_ - b.m33_);
	}
	/** s̊|Z@ab̏ԂςƌʂႤ
	 * @param a |s
	 * @param b |s
	 */
	public static Matrix mul(Matrix a, Matrix b) {
		return new Matrix(
				a.m00_ * b.m00_ + a.m01_ * b.m10_ + a.m02_ * b.m20_ + a.m03_ * b.m30_,
				a.m00_ * b.m01_ + a.m01_ * b.m11_ + a.m02_ * b.m21_ + a.m03_ * b.m31_,
				a.m00_ * b.m02_ + a.m01_ * b.m12_ + a.m02_ * b.m22_ + a.m03_ * b.m32_,
				a.m00_ * b.m03_ + a.m01_ * b.m13_ + a.m02_ * b.m23_ + a.m03_ * b.m33_,
				a.m10_ * b.m00_ + a.m11_ * b.m10_ + a.m12_ * b.m20_ + a.m13_ * b.m30_,
				a.m10_ * b.m01_ + a.m11_ * b.m11_ + a.m12_ * b.m21_ + a.m13_ * b.m31_,
				a.m10_ * b.m02_ + a.m11_ * b.m12_ + a.m12_ * b.m22_ + a.m13_ * b.m32_,
				a.m10_ * b.m03_ + a.m11_ * b.m13_ + a.m12_ * b.m23_ + a.m13_ * b.m33_,
				a.m20_ * b.m00_ + a.m21_ * b.m10_ + a.m22_ * b.m20_ + a.m23_ * b.m30_,
				a.m20_ * b.m01_ + a.m21_ * b.m11_ + a.m22_ * b.m21_ + a.m23_ * b.m31_,
				a.m20_ * b.m02_ + a.m21_ * b.m12_ + a.m22_ * b.m22_ + a.m23_ * b.m32_,
				a.m20_ * b.m03_ + a.m21_ * b.m13_ + a.m22_ * b.m23_ + a.m23_ * b.m33_,
				a.m30_ * b.m00_ + a.m31_ * b.m10_ + a.m32_ * b.m20_ + a.m33_ * b.m30_,
				a.m30_ * b.m01_ + a.m31_ * b.m11_ + a.m32_ * b.m21_ + a.m33_ * b.m31_,
				a.m30_ * b.m02_ + a.m31_ * b.m12_ + a.m32_ * b.m22_ + a.m33_ * b.m32_,
				a.m30_ * b.m03_ + a.m31_ * b.m13_ + a.m32_ * b.m23_ + a.m33_ * b.m33_);
	}
	/** s]
	 * @param rx x𒆐Sɂĉ]px(WA)
	 * @param ry y𒆐Sɂĉ]px(WA)
	 * @param rz z𒆐Sɂĉ]px(WA)
	 */	
	public void rotate(double rx, double ry, double rz) {
		double sinx = Math.sin(rx);
		double cosx = Math.cos(rx);
		double siny = Math.sin(ry);
		double cosy = Math.cos(ry);
		double sinz = Math.sin(rz);
		double cosz = Math.cos(rz);

		Matrix mx = new Matrix (1, 0,     0,    0,
								0,  cosx, sinx, 0,
								0, -sinx, cosx, 0,
								0, 0,     0,    1);
		Matrix my = new Matrix (cosy, 0, -siny, 0,
								0,    1, 0,     0,
								siny, 0,  cosy, 0,
								0,    0, 0,     1);
		Matrix mz = new Matrix ( cosz, sinz, 0, 0,
								-sinz, cosz, 0, 0,
								0,     0,    1, 0,
								0,     0,    0, 1);

	
		copy(Matrix.mul(Matrix.mul(mz, my), mx));	
	}
	/** s̋t]
	 * @param rx x𒆐Sɂċt]px(WA)
	 * @param ry y𒆐Sɂċt]px(WA)
	 * @param rz z𒆐Sɂċt]px(WA)
	 */	
	public void revRotate(double rx, double ry, double rz) {
		double sinx = Math.sin(rx);
		double cosx = Math.cos(rx);
		double siny = Math.sin(ry);
		double cosy = Math.cos(ry);
		double sinz = Math.sin(rz);
		double cosz = Math.cos(rz);

		Matrix mx = new Matrix (1, 0,     0,    0,
								0,  cosx, sinx, 0,
								0, -sinx, cosx, 0,
								0, 0,     0,    1);
		Matrix my = new Matrix (cosy, 0, -siny, 0,
								0,    1, 0,     0,
								siny, 0,  cosy, 0,
								0,    0, 0,     1);
		Matrix mz = new Matrix ( cosz, sinz, 0, 0,
								-sinz, cosz, 0, 0,
								0,     0,    1, 0,
								0,     0,    0, 1);

	
		copy(Matrix.mul(Matrix.mul(my, mx), mz));
	}

	/** s̕sړ
	 * @param tx xړ
	 * @param ty tړ
	 * @param tz zړ
	 */
	public void trans(double tx, double ty, double tz) {
		Matrix t = new Matrix(1, 0, 0, 0,
							  0, 1, 0, 0,
							  0, 0, 1, 0,
							  tx, ty, tz, 1);
		copy(Matrix.mul(this, t));
	}
	
	/** s]
	 * @param v ]p̃xNg
	 */
	public void rotate(Vertex v) {
		rotate(v.x_, v.y_, v.z_);
	}
	/** st]
	 * @param v t]p̃xNg
	 */
	public void revRotate(Vertex v) {
		revRotate(v.x_, v.y_, v.z_);
	}
	/** s𕽍sړ
	 * @param v t]p̃xNg
	 */
	public void trans(Vertex v) {
		trans(v.x_, v.y_, v.z_);
	}
	/** ts߂
	 * @param m ̍s
	 * @return ts
	 */
	public static Matrix inverse(Matrix m) {
		return new Matrix(
			m.m00_, m.m10_, m.m20_, 0.0,
			m.m01_, m.m11_, m.m21_, 0.0,
			m.m02_, m.m12_, m.m22_, 0.0,
			-( m.m00_ * m.m30_ + m.m01_ * m.m31_ + m.m02_ * m.m32_ ),
			-( m.m10_ * m.m30_ + m.m11_ * m.m31_ + m.m12_ * m.m32_ ),
			-( m.m20_ * m.m30_ + m.m21_ * m.m31_ + m.m22_ * m.m32_ ),
			1.0);
	}
}


/** ʂ\
 * @version 1.0.0
 * @author kikuchi
 */
class Face {
	// _
	public Vertex v_[];
	// @
	public Vertex normal_;
	// 
	public double dist_;
	/** RXgN^
	 * @param num o^_̐
	 * @param p _̔z 3ȏł邱ƂK{
	 */
	public Face(int num, Vertex[] p) {
		v_ = new Vertex[num];
		for (int i = 0; i < num; i --) {
			v_[i] = p[i];
		}
		normal();
	}
	/** RXgN^
	 * @param p _̔z 3ȏł邱ƂK{
	 */
	public Face(Vertex[] p) {
		this(p.length, p);
	}
	/** RXgN^ _͐ݒ肳Ȃ̂ŁAnormal()͌Ă΂Ȃ̂Œ
	 * @param p _̐
	 */
	public Face(int num) {
		v_ = new Vertex[num];
		for (int i = 0; i < num; i ++)
			v_[i] = new Vertex(0, 0, 0);
	}
	
	/** __ 1_O_̃xNg@߂
	 */
	public void normal() {
		Vertex a = Vertex.sub(v_[1], v_[0]);
		Vertex b = Vertex.sub(v_[2], v_[0]);
		double x = a.y_ * b.z_ - a.z_ * b.y_;
		double y = a.z_ * b.x_ - a.x_ * b.z_;
		double z = a.x_ * b.y_ - a.y_ * b.x_;
		double v = Math.sqrt(x * x + y * y + z * z);
		normal_ = new Vertex(x / v, 
							 y / v, 
							 z / v);
		dist_ = Vertex.dot(normal_, v_[0]);
	}
	/** sړ
	 * @param a ړƕ
	 */
	public void movePa(Vertex a) {
		for (int i = 0; i < v_.length; i --) {
			v_[i].movePa(a);
		}
		normal();
	}
	

}

/** `ʂ\NX
 * ʏɂ邩ǂ́AmȂ
 * @version 1.0.0
 * @author kikuchi
 */
class Face4 extends Face {
	/** RXgN^
	 * @d -- c
	 *   |    |
	 *   a -- b
	 * @param a _1
	 * @param b _2
	 * @param c _3
	 * @param d _4
	 */
	public Face4(Vertex a, Vertex b, Vertex c, Vertex d) {
		super(4);
		v_[0] = a;
		v_[1] = b;
		v_[2] = c;
		v_[3] = d;
		normal();
	}
	/** RXgN^
	 */
	public Face4() {
		super(4);
	}
}

/** Cube(n__xy,yz,zxɕsȗ)\NX
 * @version 1.0.0
 * @author kikuchi
 */
class Cube {
	public Face4 f_[] = new Face4[6];
	/** RXgN^
	 * @param l ̂̑傫
	 * @param x N_Wx
	 * @param y N_Wy
	 * @param z N_Wz
	 */
	public Cube(double l, double x, double y, double z) {
		Vertex p[] = new Vertex[8];
		// _
		p[0] = new Vertex(x, y, z);
		p[1] = new Vertex(x + l, y, z);
		p[2] = new Vertex(x + l, y + l, z);
		p[3] = new Vertex(x, y + l, z);
		p[4] = new Vertex(x, y, z + l);
		p[5] = new Vertex(x + l, y, z + l);
		p[6] = new Vertex(x + l, y + l, z + l);
		p[7] = new Vertex(x, y + l, z + l);
		// 
		f_[0] = new Face4(p[0], p[1], p[2], p[3]);
		//f_[1] = new Face4(p[1], p[2], p[6], p[5]);
		f_[1] = new Face4(p[1], p[5], p[6], p[2]);
		f_[2] = new Face4(p[5], p[4], p[7], p[6]);
		//f_[3] = new Face4(p[4], p[7], p[3], p[0]);
		f_[3] = new Face4(p[4], p[0], p[3], p[7]);
		f_[4] = new Face4(p[0], p[4], p[5], p[1]);
		f_[5] = new Face4(p[3], p[2], p[6], p[7]);
	}
	/** sړ
	 * @param a ړƕ
	 */
	public void movePa(Vertex a) {
		for (int i = 0; i < f_.length; i --) {
			f_[i].movePa(a);
		}
	}
}