package jp.ac.nime.computer.mailsim;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jp.ac.nime.computer.*;


/**
 * MAILV~[^@L[ԕ\`NX
 * 
 * @version 1.00 2003/03/31
 * @author Toshikazu Matsumoto Avion Corp.
 */
public class QueueStatusCanvas extends Canvas implements Runnable
{
	private Component	m_Parent;	//eR|[lg
	private MailSim		m_Applet;	//CAvbgNX
	private MailServItem m_Item;	//ĂяoT[o[IuWFNg
	private	Thread		m_Thread;	//Xbh
	private Vector		m_vcMail;	//L[i[[IuWFNg
	private Image		m_imOff;	//ItXN[C[W
	private Image		m_imMail;	//[摜
	private	int			m_nOffset=0;	//\ʒuItZbg
	private	boolean		m_bStop=false;	//Xbh̒~tO
	
	/**
	 * NXRXgN^
	 * @param parent eR|[lg
	 * @param applet CAvbgNX
	 * @param item ĂяoT[o[IuWFNg
	 * @param imMail [摜
	 */
	public QueueStatusCanvas(Component parent,MailSim applet,MailServItem item,Image imMail)
	{
		this.m_Parent=parent;
		this.m_Applet=applet;
		this.m_Item=item;
		this.m_imMail=imMail;
		this.start();
	}
	/**
	 * OtBbN̕`iItXN[烁CXN[ւ̉摜Rs[j
	 * @param g `OtBbN̈
	 */
	public void paint(Graphics g)
	{
		if(this.m_imOff==null)
		{
			Dimension d=this.getSize();
			this.m_imOff=this.m_Parent.createImage(d.width,d.height);
		}
		this.drawAll();
		g.drawImage(this.m_imOff,0,0,this);
		this.m_imOff.flush();
	}
	/**
	 * OtBbNĕ`
	 * @param g `OtBbN̈
	 */
	public void update(Graphics g)
	{
		this.paint(g);
	}
	/**
	 * ItXN[C[Wւ̊eOtBbN̕`
	 */
	public void drawAll()
	{
		Graphics g=this.m_imOff.getGraphics();
		this.drawBack(g);
		this.drawMail(g);
	}
	/**
	 * wi摜̕`
	 * @param g `OtBbN̈
	 */
	private void drawBack(Graphics g)
	{
		g.setColor(new Color(57,109,165));
		g.fillRect(0,0,this.getSize().width,this.getSize().height);
		g.setColor(Color.black);
		g.drawRect(100,(this.getSize().height-60)/2,280,60);
	}
	/**
	 * ړ郁[摜̕`
	 * @param g `OtBbN̈
	 */
	private void drawMail(Graphics g)
	{
		Vector vcMail=this.m_Item.getQueue();
		for(int i=0;i<vcMail.size();i++)
		{
			try
			{
				MailDataObject objMail=(MailDataObject)vcMail.elementAt(i);
				Image icon=objMail.getIcon();
				int nProcess=objMail.getProcess();
				g.drawImage(icon,this.getSize().width-(int)((float)(this.getSize().width*objMail.getProcess())/200),80+10,this);
			}
			catch(Exception e)
			{
				System.out.println(e.toString());
				this.stop();
				return;
			}
		}
	}
	/**
	 * Xbh̊JnA
	 */
	public void start()
	{
		if(this.m_Thread==null)
		{
			this.m_Thread=new Thread(this);
		}
		this.m_Thread.start();
	}
	/**
	 * Xbh̎s
	 */
	public void run()
	{
		while(!this.m_bStop&&this.m_Thread!=null)
		{
			Vector vcMail=this.m_Item.getQueue();
			for(int i=0;i<vcMail.size();i++)
			{
				try
				{
					MailDataObject objMail=(MailDataObject)vcMail.elementAt(i);
					Image icon=objMail.getIcon();
					int nProcess=objMail.getProcess();
					int nStatus =objMail.getStatus();
					if(nStatus!=MailDataObject.MAIL_STATUS_FOR_QUEUE)
					{
						continue;
					}
					
					if(nProcess>=200)
					{
						//M̌o
						String sTo=objMail.getTo();
						int index=sTo.indexOf("@");
						boolean bError=true;
						if(index!=-1)
						{
							String sHost=sTo.substring(index+1);
							for(int j=0;j<this.m_Item.getTargetSize();j++)
							{
								MachineItem item=this.m_Item.getTarget(j);
								if(sHost.compareTo(item.getHost())==0)
								{
									objMail.setMoveObject(this.m_Item,item);
									bError=false;
								}
							}
						}
						if(bError==true)
						{
							objMail.setStatus(MailDataObject.MAIL_STATUS_REACH_SPOOL);
							objMail.setProcess(1);
							this.m_Item.addSpool(objMail);
						}
						else
						{
							objMail.setStatus(nStatus+1);
							objMail.setProcess(1);
							this.m_Applet.addPacket(objMail);
						}
						this.m_Item.deQueue(i);
															
						continue;
					}			
				}
				catch(Exception e)
				{
					System.out.println(e.toString());
					this.stop();
					return;
				}
			}			
			try
			{
				this.m_Thread.sleep(100);
			}
			catch(InterruptedException e)
			{
				this.m_bStop=true;
				this.m_Thread=null;
			}
			repaint();
		}
	}
	/**
	 * Xbh̒~
	 */
	public void stop()
	{
		//this.m_Thread.stop();
		this.m_bStop=true;
		this.m_Thread=null;
	}
	/**
	 * Xbḧꎞ~
	 */
	public void suspendThread()
	{
		this.m_Thread.suspend();
		Vector vcMail=this.m_Item.getQueue();
		for(int i=0;i<vcMail.size();i++)
		{
			MailDataObject objMail=(MailDataObject)vcMail.elementAt(i);
			objMail.suspend();
		}
	}
	/**
	 * Xbh̍ĊJ
	 */
	public void resumeThread()
	{
		this.m_Thread.resume();
		Vector vcMail=this.m_Item.getQueue();
		for(int i=0;i<vcMail.size();i++)
		{
			MailDataObject objMail=(MailDataObject)vcMail.elementAt(i);
			objMail.resume();
		}

	}
}