package jp.ac.nime.computer.mailsim;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jp.ac.nime.computer.*;

/**
 * MAILV~[^@Oobt@ԕ\`NX
 * 
 * @version 1.00 2003/03/31
 * @author Toshikazu Matsumoto Avion Corp.
 */
public class RingBufCanvas extends Canvas implements Runnable
{
	public final static int	RING_BUF_MODE_ENQUEUE=0;
	public final static int	RING_BUF_MODE_DEQUEUE=1;
	
	private Component	m_Parent;		//eR|[lg
	private RingBufDialog m_Dialog;		//e_CAONX
	private Image		m_imMail;		//[摜
	private Image		m_imOff=null;	//ItXN[C[W
	private Vector		m_vcRingBuf;	//Oobt@ɒ܂ĂIuWFNg
	private Thread		m_Thread;		//Xbh
	private	int			m_nOffset=0;	//`ʒuItZbg
	private int			m_nFront=0;		//Oobt@AOʒu
	private int			m_nRear=0;		//Oobt@Aʒu
	private int			m_nMode=RING_BUF_MODE_ENQUEUE;
	private MailDataObject	m_Target;	//ꎞێp[f[^IuWFNg
	
	/**
	 * NXRXgN^
	 * @param parent eR|[lg
	 * @param dialog e_CAO
	 * @param imMail [摜
	 */
	public RingBufCanvas(Component parent,RingBufDialog dialog,Image imMail)
	{
		this.m_Parent=parent;
		this.m_Dialog=dialog;
		this.m_imMail=imMail;
		this.m_vcRingBuf=new Vector();
	}
	/**
	 * OtBbN`iItXN[烁CXN[ւ̉摜Rs[j
	 * @param g `OtBbN̈
	 */
	public void paint(Graphics g)
	{
		if(this.m_imOff==null)
		{
			Dimension d=this.getSize();
			this.m_imOff=this.m_Parent.createImage(d.width,d.height);
		}
		this.drawAll();
		g.drawImage(this.m_imOff,0,0,this.m_Parent);
		this.m_imOff.flush();
	}
	/**
	 * OtBbNĕ`
	 * @param g `OtBbN̈
	 */
	public void update(Graphics g)
	{
		this.drawAll();
		this.paint(g);
	}
	/**
	 * ItXN[ւ̕`BItXN[C[WGraphics擾B
	 */
	private void drawAll()
	{
		Graphics g=this.m_imOff.getGraphics();
		this.drawBack(g);
		this.drawQueue(g);
	}
	/**
	 * wiȂǂ̕`
	 * @param g `OtBbN̈
	 */
	private void drawBack(Graphics g)
	{
		g.setColor(new Color(57,109,165));
		g.fillRect(0,0,this.getSize().width,this.getSize().height);
		g.setColor(Color.black);
		for(int i=0;i<5;i++)
		{
			g.drawRect(100,20+(i*63),130,63);
		}
		
		for(int i=0;i<this.m_vcRingBuf.size();i++)
		{
			MailDataObject objMail=(MailDataObject)this.m_vcRingBuf.elementAt(i);
			int nPos=this.m_nFront+i;
			if(nPos>=5)
			{
				nPos=0;
			}
			g.drawImage(objMail.getIcon(),120,30+nPos*63,this.m_Parent);
		}
	}
	/**
	 * Aj[V郁[摜̕`
	 * @param g `OtBbN̈
	 */
	private void drawQueue(Graphics g)
	{
		switch(this.m_nMode)
		{
		case RING_BUF_MODE_ENQUEUE:
			if(this.m_Target!=null)
			{
				g.drawImage(this.m_Target.getIcon(),this.m_nOffset,this.m_nRear*63+30,this.m_Parent);
			}
			break;
		case RING_BUF_MODE_DEQUEUE:
			if(this.m_Target!=null)
			{
				int nPos=this.m_nFront-1;
				if(nPos<0)this.m_nFront=4;
				g.drawImage(this.m_Target.getIcon(),this.m_nOffset,nPos*63+30,this.m_Parent);
			}
			break;
		}
	}
	/**
	 * Xbh̊JnA
	 */
	public void start()
	{
		if(this.m_Thread==null)
		{
			this.m_Thread=new Thread(this);
		}
		this.m_Thread.start();
	}
	/**
	 * Xbh̎s
	 */
	public void run()
	{
		while(this.m_Thread!=null)
		{
			switch(this.m_nMode)
			{
			case RING_BUF_MODE_ENQUEUE:
				if(this.m_nOffset==120)
				{
					this.m_Thread=null;
					this.m_nOffset=0;
					this.m_vcRingBuf.addElement(this.m_Target);
					this.m_Target=null;
					this.m_nRear++;
					
					if(this.m_nRear>=5)
					{
						this.m_nRear=0;
					}
					
					if(this.m_vcRingBuf.size()>=5)
					{
						this.m_Dialog.setOver();
					}
					if(this.m_vcRingBuf.size()>0)
					{
						this.m_Dialog.canDequeue();
					}
					break;
				}
				this.m_nOffset+=2;
				break;
			case RING_BUF_MODE_DEQUEUE:
				if(this.m_nOffset==-90)
				{
					this.m_Thread=null;
					this.m_nOffset=0;
					//this.m_nFront++;
					this.m_Target=null;
					if(this.m_nFront>=5)
					{
						this.m_nFront=0;
					}
					break;
				}
				this.m_nOffset-=2;
				break;
			}
			try
			{
				this.m_Thread.sleep(10);
			}
			catch(InterruptedException e)
			{
				this.m_Thread=null;
				break;
			}
			this.repaint();
		}
	}
	/**
	 * Xbh̒~
	 */
	public void stop()
	{
		this.m_Thread=null;
	}
	/**
	 * Oobt@փf[^̊i[
	 */
	public void enQueue()
	{
		this.m_Target=new MailDataObject(this.m_Parent,this.m_imMail,"foo"+this.m_vcRingBuf.size()+"@foo.co.jp");
		//this.m_vcRingBuf.addElement(objMail);
		this.m_nMode=RING_BUF_MODE_ENQUEUE;
		this.start();
	}
	/**
	 * Oobt@f[^̎o
	 */
	public void deQueue()
	{
		this.m_Target=(MailDataObject)this.m_vcRingBuf.elementAt(0);
		this.m_vcRingBuf.removeElementAt(0);
		this.m_nFront++;
		this.m_nMode=RING_BUF_MODE_DEQUEUE;
		this.m_nOffset=120;
		
		if(this.m_vcRingBuf.size()<=0)
		{
			this.m_Dialog.setEmpty();
		}
		if(this.m_vcRingBuf.size()<5)
		{
			this.m_Dialog.canEnqueue();
		}
		this.start();
	}
}