package jp.ac.nime.computer.mailsim;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import jp.ac.nime.computer.*;

/**
 * MAILV~[^@[M_CAO
 * 
 * @version 1.00 2003/03/31
 * @author Toshikazu Matsumoto Avion Corp.
 */
public class SendMailDialog extends JDialog implements ActionListener
{
	public final static int DIALOG_MODE_SEND = 1;
	public final static int DIALOG_MODE_VIEW = 2;
	
	private MailSim		m_Applet;	//CAvbgNX
	private PcItem m_Item;			//ĂяoPCIuWFNg
	private JTextField m_tfTo;		//TOeLXgtB[h
	private JTextField m_tfCc;		//CCeLXgtB[h
	private JTextField m_tfBcc;		//BCCeLXgtB[h
	private JTextArea m_taData;		//[{̓eLXgGA
	
	private JButton m_btSend;		//M{^
	private JButton m_btJisSend;	//JISɕϊđM{^
	private JButton m_btCancel;		//LZ{^
	
	private int		m_nMode;		//[M{̃[h
	
	/**
	 * NXRXgN^
	 * @param root et[NX
	 * @param applet CAvbgNX
	 * @param item ĂяoPCIuWFNgNX
	 * @param nMode M{̃[h
	 */	
	public SendMailDialog(Frame root,MailSim applet,PcItem item,int nMode)
	{
		super(root,"[M");
		this.m_Applet=applet;
		this.m_Item=item;
		this.m_nMode=nMode;
		
		this.m_tfTo=new JTextField(30);
		this.m_tfCc=new JTextField(30);
		this.m_tfBcc=new JTextField(30);
		this.m_taData=new JTextArea();
		this.m_taData.setRows(10);
		
		if(nMode==DIALOG_MODE_VIEW)
		{
			this.m_tfTo.setEnabled(false);
			this.m_tfCc.setEnabled(false);
			this.m_tfBcc.setEnabled(false);
			this.m_taData.setEnabled(false);
		}
		
		this.m_btSend=new JButton("M");
		this.m_btJisSend=new JButton("JISɕϊđM");
		this.m_btCancel=new JButton("LZ");
		
		this.m_btSend.addActionListener(this);
		this.m_btJisSend.addActionListener(this);
		
		this.m_btCancel.addActionListener(this);
		
		this.makeLayout();
		this.pack();
		Toolkit tool=Toolkit.getDefaultToolkit();
		Dimension d=tool.getScreenSize();
		
		this.setLocation(new Point((d.width-this.getSize().width)/2,(d.height-this.getSize().height)/2));
		//this.show();
	}
	/**
	 * etB[hɃf[^̃Zbg
	 * @param objMail Zbg郁[f[^IuWFNg
	 */
	public void setData(MailDataObject objMail)
	{
		this.m_tfTo.setText(objMail.getTo());
		this.m_tfCc.setText(objMail.getCc());
		this.m_tfBcc.setText(objMail.getBcc());
		
		
		//if(objMail.isJisEnc()==true)
		//{
		try
		{
			String sData=new String(objMail.getBody().getBytes("8859_1"),"ISO2022JP");
			this.m_taData.setText(sData);
		}
		catch(UnsupportedEncodingException e)
		{
			return;
		}
		//}
		//else
		//{
		//	this.m_taData.setText(objMail.getBody());
		//}
	}
	/**
	 * CAEg̍\z
	 */
	private void makeLayout()
	{
		Panel pText=new Panel();
		GridBagLayout layout=new GridBagLayout();
		GridBagConstraints c=new GridBagConstraints();
		pText.setLayout(layout);
		
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;
		c.gridwidth = GridBagConstraints.RELATIVE;
		JLabel lto=new JLabel("TO:");
		layout.setConstraints(lto,c);
		pText.add(lto);
		c.gridwidth = GridBagConstraints.REMAINDER;
		layout.setConstraints(this.m_tfTo, c);
		pText.add(this.m_tfTo);
		
		c.weightx = 0.0;
		c.gridwidth = GridBagConstraints.RELATIVE;
		JLabel lcc=new JLabel("CC:");
		layout.setConstraints(lcc,c);
		pText.add(lcc);
		c.gridwidth = GridBagConstraints.REMAINDER;
		layout.setConstraints(this.m_tfCc, c);
		pText.add(this.m_tfCc);

		c.weightx = 0.0;
		c.gridwidth = GridBagConstraints.RELATIVE;
		JLabel lbcc=new JLabel("BCC:");
		layout.setConstraints(lbcc,c);
		pText.add(lbcc);
		c.gridwidth = GridBagConstraints.REMAINDER;
		layout.setConstraints(this.m_tfBcc, c);
		pText.add(this.m_tfBcc);
		
		Panel pButton=new Panel();
		pButton.setLayout(new FlowLayout(FlowLayout.CENTER));
		pButton.add(this.m_btSend);
		pButton.add(this.m_btJisSend);
		pButton.add(this.m_btCancel);
				
		this.getContentPane().setLayout(new BorderLayout());
		this.getContentPane().add("North",pText);
		this.getContentPane().add("Center",this.m_taData);
		
		if(this.m_nMode==DIALOG_MODE_SEND)
		{
			this.getContentPane().add("South",pButton);
		}
	}
	/**
	 * e{^̃ANV
	 */
	public void actionPerformed(ActionEvent evt)
	{
		//M{^
		if(evt.getSource() == this.m_btSend)
		{
			MailDataObject objMail=new MailDataObject((Component)m_Applet,this.m_Applet.getImageArray(3),this.m_tfTo.getText());
			objMail.setFrom(this.m_Item.getAccount());
			objMail.setCc(this.m_tfCc.getText());
			objMail.setBcc(this.m_tfBcc.getText());
			objMail.setBody(this.m_taData.getText());
			objMail.makeHeader();
			objMail.setMoveObject((MachineItem)this.m_Item,this.m_Item.getTarget(0));
			this.m_Applet.addPacket(objMail);
			objMail.startThread();
			this.dispose();
		}
		//JISɕϊđM{^
		else if(evt.getSource() == this.m_btJisSend)
		{
			MailDataObject objMail=new MailDataObject((Component)m_Applet,this.m_Applet.getImageArray(3),this.m_tfTo.getText());
			objMail.setFrom(this.m_Item.getAccount());
			objMail.setCc(this.m_tfCc.getText());
			objMail.setBcc(this.m_tfBcc.getText());
			try
			{
				String sBody=new String(this.m_taData.getText().getBytes("ISO2022JP"),"8859_1");
				objMail.setBody(sBody);
			}
			catch(UnsupportedEncodingException e)
			{
				objMail.setBody(this.m_taData.getText());
			}
			objMail.setJisEnc(true);
			objMail.makeHeader();
			objMail.setMoveObject((MachineItem)this.m_Item,this.m_Item.getTarget(0));
			this.m_Applet.addPacket(objMail);
			objMail.startThread();
			this.dispose();
		}
		//LZ{^
		else if(evt.getSource() == this.m_btCancel)
		{
			this.dispose();
		}
	}
}